//
//  RootViewController.m
//  PlayDemo0.6
//
//  Created by psdk on 15/6/16.
//  Copyright (c) 2015年 Dahua. All rights reserved.
//

#import "RootViewController.h"
#import "ViewController.h"
#import "FileListViewController.h"

@interface RootViewController ()
@property (strong, nonatomic) ViewController * vc;
@property (strong, nonatomic) FileListViewController* flvc;
@end

@implementation RootViewController

- (void)viewDidLoad {
    [super viewDidLoad];
    
    self.vc = [self.storyboard instantiateViewControllerWithIdentifier:@"PLAY"];
    self.flvc = [self.storyboard instantiateViewControllerWithIdentifier:@"FLVC"];
    
    self.vc.rootvc = self;
    self.vc.flvc = self.flvc;
    self.flvc.rootvc = self;
    
    [self.view insertSubview:self.vc.view atIndex:1];
}

- (void)didReceiveMemoryWarning {
    [super didReceiveMemoryWarning];
}

-(void)changeVC:(int)type
{
    if(type == 0)
    {
        [self.flvc.view removeFromSuperview];
        
        [UIView beginAnimations:@"View Flip" context:NULL];
        [UIView setAnimationDuration:0.4];
        [UIView setAnimationCurve:UIViewAnimationCurveEaseInOut];
        [UIView setAnimationTransition:UIViewAnimationTransitionFlipFromRight forView:self.view cache:YES];
        
        [self.view insertSubview:self.vc.view atIndex:1];
        
        [UIView commitAnimations];
    }
    else
    {
        [self.vc.view removeFromSuperview];
        
        [UIView beginAnimations:@"View Flip" context:NULL];
        [UIView setAnimationDuration:0.4];
        [UIView setAnimationCurve:UIViewAnimationCurveEaseInOut];
        [UIView setAnimationTransition:UIViewAnimationTransitionFlipFromLeft forView:self.view cache:YES];
        
        [self.view insertSubview:self.flvc.view atIndex:1];
        
        [UIView commitAnimations];
    }
}

-(void)willAnimateRotationToInterfaceOrientation:(UIInterfaceOrientation)toInterfaceOrientation duration:(NSTimeInterval)duration
{
    [self.vc willAnimateRotationToInterfaceOrientation:toInterfaceOrientation duration:duration];
}

-(NSUInteger)supportedInterfaceOrientations
{
    return [self.vc supportedInterfaceOrientations];
}

@end
