//
//  ViewController.m
//  PlayDemo0.6
//
//  Created by psdk on 15/5/14.
//  Copyright (c) 2015年 Dahua. All rights reserved.
//

#import "ViewController.h"
#import "dhplay.h"

enum state_play
{
    state_play_init=0,
    state_play_open,
    state_play_play,
    state_play_stop,
    state_play_close,
};

@interface MySlider : UISlider
@property (strong, nonatomic) ViewController * h;
-(void) setHP:(ViewController*) h;
@end

@interface ViewController ()
- (IBAction)on_slider_value_changed:(UISlider *)sender;
- (IBAction)on_bt_slow_press:(UIButton *)sender;
- (IBAction)on_bt_fast_press:(id)sender;
- (IBAction)on_bt_pause_press:(UIButton *)sender;
- (IBAction)on_bt_record_press:(UIButton *)sender;
- (IBAction)on_snappic:(id)sender;
- (NSString*)ct;
@property (strong, nonatomic) IBOutlet UIButton *bt_hw;
- (IBAction)on_bt_hw_press:(UIButton *)sender;
@property (strong, nonatomic) IBOutlet UIButton *bt_snappic;
@property (strong, nonatomic) IBOutlet UILabel *label_speed;
@property (strong, nonatomic) IBOutlet UIButton *bt_record;
@property (strong, nonatomic) IBOutlet UIButton *bt_slow;
@property (strong, nonatomic) IBOutlet UIButton *bt_fast;
@property (strong, nonatomic) IBOutlet UIButton *bt_stop;
@property (strong, nonatomic) IBOutlet UIButton *bt_pause;
- (IBAction)on_slider_contrast:(id)sender;
- (IBAction)on_slider_saturation:(id)sender;
@property (strong, nonatomic) IBOutlet UISlider *slider_hue;
@property (strong, nonatomic) IBOutlet MySlider *slider_process;
- (IBAction)on_slider_hue:(id)sender;
@property (strong, nonatomic) IBOutlet UIButton *bt_play;
@property (strong, nonatomic) IBOutlet UISlider *slider_saturation;
@property (strong, nonatomic) IBOutlet UILabel *label_Hue;
@property (strong, nonatomic) IBOutlet UISlider *slider_contrast;
@property (strong, nonatomic) IBOutlet UIButton *bt_open;
@property (strong, nonatomic) IBOutlet UILabel *stateLabel;
@property (weak, nonatomic) IBOutlet UILabel *pt;
@property (strong, nonatomic) IBOutlet UILabel *label_Saturation;
@property (strong, nonatomic) IBOutlet UILabel *label_contrast;
//@property (strong, nonatomic) IBOutlet UILabel *label_Saturation;
@property (strong, nonatomic) IBOutlet UIButton *bt_config;
@property (strong, nonatomic) IBOutlet UILabel *label_Brightness;
@property (strong, nonatomic) IBOutlet UILabel *label_Contrast;
- (IBAction)on_bt_config:(id)sender;
@property (strong, nonatomic) IBOutlet UISlider *slider_bright;
- (IBAction)on_bright_valuechanged:(id)sender;
- (IBAction)on_slider_begin:(id)sender;
//@property (strong, nonatomic) IBOutlet UILabel *label_Contrast;
@property (strong, nonatomic) IBOutlet UIButton *bt_pressure;
- (IBAction)on_slider_touch_up:(id)sender;
- (IBAction)on_pressure_press:(id)sender;
@property (strong, nonatomic) NSTimer *timer;
@property BOOL is_bt_record_on;
@property (strong, nonatomic) NSThread* thread_inputdata;
@property (strong, nonatomic) NSThread* thread_pressure;
@property enum state_play state;
@property BOOL is_hw;
@property int speed;
- (void) run;
@end

@implementation ViewController

static const CGFloat buttonHeight = 40;
static const CGFloat buttonWidth = 40;
static const CGFloat labelWidht = 100;
static const CGFloat labelHeight = 30;
static const CGFloat spacing = 8;
static NSString* record_file_name;

extern BOOL PLAY_CleanScreen(LONG nPort, float red, float green, float blue, float alpha, DWORD nRegionNum);

- (NSString*)ct
{
    NSDate* data = [NSDate date];
    
    NSCalendar* cal = [NSCalendar currentCalendar];
    unsigned int f = NSYearCalendarUnit | NSMonthCalendarUnit | NSDayCalendarUnit | NSHourCalendarUnit | NSMinuteCalendarUnit | NSSecondCalendarUnit;
    
    NSDateComponents* d = [cal components:f fromDate:data];
    NSString* temp = [NSString stringWithFormat:@"%ld.%ld.%ld.%ld.%ld.%ld", (long)[d year], (long)[d month], (long)[d day], (long)[d hour], (long)[d minute], (long)[d second]];
    
    return temp;
}

- (void)viewDidLoad {
    [super viewDidLoad];
    
    CGRect b = self.view.bounds;
    NSLog(@"bounds %f %f", b.size.width, b.size.height);
    
    self.pt.frame = CGRectMake(0, 20, CGRectGetWidth(b), 30);
    CGRect rect = {
        0,
        self.pt.frame.origin.y + self.pt.frame.size.height,
        b.size.width,
        b.size.width*3/4};
    
    view2 = [[DHVideoWnd alloc] initWithFrame: rect];
    [self.view addSubview:view2];
    
    self.slider_process = [[MySlider alloc] initWithFrame:CGRectMake(0,
                        self.pt.frame.origin.y + 8 + self.pt.frame.size.height + b.size.width*3/4+2,
                        CGRectGetWidth(b),
                        20)];
    [self.slider_process addTarget:self action:@selector(on_slider_value_changed:) forControlEvents:UIControlEventValueChanged];
    [self.slider_process setHP:self];
    
    [self.view addSubview:self.slider_process];
    self.label_Brightness.frame = CGRectMake(CGRectGetWidth(b)/5,
                                             self.pt.frame.origin.y + self.pt.frame.size.height+
                                             60,
                                             labelWidht, labelHeight);
    self.label_Brightness.text = [NSString stringWithFormat:@"Brightness"];
    self.slider_bright.frame = CGRectMake(self.label_Brightness.frame.origin.x+
                                          self.label_Brightness.frame.size.width+spacing,
                                          self.label_Brightness.frame.origin.y ,
                                          CGRectGetWidth(b)/3,
                                          30);
    
    self.label_Contrast.frame = CGRectMake(self.label_Brightness.frame.origin.x,
                                            self.label_Brightness.frame.origin.y +
                                           self.label_Brightness.frame.size.height+spacing,
                                              labelWidht, labelHeight);
     self.label_Contrast.text = [NSString stringWithFormat:@"Contrast"];
    self.slider_contrast.frame = CGRectMake(self.label_Contrast.frame.origin.x+
                                            self.label_Contrast.frame.size.width+spacing,
                                            self.label_Contrast.frame.origin.y ,
                                          CGRectGetWidth(b)/3,
                                          30);
    self.label_Saturation.frame = CGRectMake(self.label_Brightness.frame.origin.x,
                                           self.label_Contrast.frame.origin.y +
                                           self.label_Contrast.frame.size.height+spacing,
                                            labelWidht, labelHeight);
    self.label_Saturation.text = [NSString stringWithFormat:@"Saturation"];
    self.slider_saturation.frame = CGRectMake(self.label_Saturation.frame.origin.x+
                                              self.label_Saturation.frame.size.width+spacing,
                                              self.label_Saturation.frame.origin.y ,
                                            CGRectGetWidth(b)/3,
                                            30);
    self.label_Hue.frame = CGRectMake(self.label_Brightness.frame.origin.x,
                                             self.label_Saturation.frame.origin.y +
                                             self.label_Saturation.frame.size.height+spacing,
                                            labelWidht, labelHeight);
    self.label_Hue.text = [NSString stringWithFormat:@" Hue"];
    self.slider_hue.frame = CGRectMake(self.label_Hue.frame.origin.x+
                                       self.label_Hue.frame.size.width+spacing,
                                       self.label_Hue.frame.origin.y ,
                                              CGRectGetWidth(b)/3,
                                              30);

    
    self.stateLabel.frame = CGRectMake(0,
                        self.slider_process.frame.origin.y + self.slider_process.frame.size.height + spacing,
                        CGRectGetWidth(b),
                        20);
    
    CGFloat yy = self.stateLabel.frame.origin.y + self.stateLabel.frame.size.height + spacing;
    
    self.bt_open.frame = CGRectMake(0, yy, buttonWidth, buttonHeight);
    self.bt_play.frame = CGRectMake(spacing + buttonWidth, yy, buttonWidth, buttonHeight);
    
    self.bt_pause.frame = CGRectMake(spacing*2 + buttonWidth*2, yy, buttonWidth, buttonHeight);
    self.bt_stop.frame = CGRectMake(spacing*3 + buttonWidth*3, yy, buttonWidth, buttonHeight);
    self.bt_fast.frame = CGRectMake(spacing*4 + buttonWidth*4, yy, buttonWidth, buttonHeight);
    self.bt_slow.frame = CGRectMake(spacing*5 + buttonWidth*5, yy, buttonWidth, buttonHeight);
    
    //self.bt_volume.frame = CGRectMake(spacing*6 + buttonWidth*6, yy+3, buttonWidth-4, buttonHeight-4);
    self.label_speed.frame = CGRectMake(spacing*6 + buttonWidth*6, yy+3, buttonWidth-4, buttonHeight-4);
    
    self.bt_hw.frame = CGRectMake(
                        0,
                        self.bt_open.frame.origin.y + self.bt_open.frame.size.height + spacing,
                        buttonWidth*2 + spacing,
                        buttonHeight);
    [self.bt_hw setTitle:@"HW:No" forState:UIControlStateNormal];
    
    
    self.bt_snappic.frame = CGRectMake(
                        self.bt_hw.frame.origin.x + self.bt_hw.frame.size.width + spacing,
                        self.bt_hw.frame.origin.y,
                        buttonWidth*2 + spacing,
                        buttonHeight);
    
    self.bt_config.frame = CGRectMake(
                                      self.bt_snappic.frame.origin.x + self.bt_snappic.frame.size.width + spacing,
                                      self.bt_snappic.frame.origin.y,
                                      buttonWidth*2 + spacing,
                                      buttonHeight);
    
    [self.bt_config setTitle:@"Quality" forState:UIControlStateNormal];

    self.bt_record.frame = CGRectMake(
                                      self.bt_config.frame.origin.x + self.bt_config.frame.size.width + spacing,
                                      self.bt_config.frame.origin.y,
                                      buttonWidth,
                                      buttonHeight);
    
    self.timer = [NSTimer scheduledTimerWithTimeInterval:0.03f target:self selector:@selector(timercb:) userInfo:nil repeats:YES];
    
    self.is_bt_record_on = FALSE;
    
    self.state = state_play_init;
    self.is_hw = FALSE;
    self.speed = 1;
    self.label_speed.text = [NSString stringWithFormat:@"%d", 0];

    self.slider_process.minimumValue = 0;
    self.slider_process.maximumValue = 100;
    self.slider_process.value = 0;
    
    self.slider_bright.minimumValue = 0;
    self.slider_bright.maximumValue =128;
    self.slider_bright.value = 64;
    self.slider_bright.hidden = true;
    
    self.slider_contrast.minimumValue = 0;
    self.slider_contrast.maximumValue =128;
    self.slider_contrast.value = 64;
    self.slider_contrast.hidden = true;
    
    self.slider_saturation.minimumValue = 0;
    self.slider_saturation.maximumValue =128;
    self.slider_saturation.value = 64;
    self.slider_saturation.hidden = true;
    
    self.slider_hue.minimumValue = 0;
    self.slider_hue.maximumValue =128;
    self.slider_hue.value = 64;
    self.slider_hue.hidden = true;
    
    self.label_Brightness.hidden = true;
    self.label_Contrast.hidden = true;
    self.label_Saturation.hidden = true;
    self.label_Hue.hidden = true;
  
    [self.view addSubview:self.label_Brightness];
    [self.view addSubview:self.label_Contrast];
    [self.view addSubview:self.label_Saturation];
    [self.view addSubview:self.label_Hue];
    [self.view addSubview:self.slider_bright];
    [self.view addSubview:self.slider_contrast];
    [self.view addSubview:self.slider_saturation];
    [self.view addSubview:self.slider_hue];
}

-(void)viewDidAppear:(BOOL)animated
{
    NSArray * paths = NSSearchPathForDirectoriesInDomains(NSDocumentDirectory, NSUserDomainMask, YES);
    NSString* documentDirectory = [paths objectAtIndex:0];
    
    NSString* temp = self.flvc.filename;
    if (temp != @"Cancel" && temp != nil)
    {
        NSString* file = [documentDirectory stringByAppendingPathComponent:self.flvc.filename];
        
        //NSString* file = [[NSBundle mainBundle] pathForResource:@"CIF-1f"ofType:@"dav"];
        
        const char* filename = [file UTF8String];
        
        self.pt.text = [NSString stringWithFormat:@"%@  %@", @"PlayDemo", self.flvc.filename];
        
        if(!self.flvc.streammode)
        {
            PLAY_OpenFile(0, (char*)filename);
        }
        else
        {
            PLAY_SetStreamOpenMode(0, STREAME_FILE);
            PLAY_OpenStream(0, NULL, 0, 5*1024*1024);
        }
        
        self.state = state_play_open;
    }
    else
    {
        self.pt.text = @"PlayDemo";
    }
}

- (void)didReceiveMemoryWarning {
    [super didReceiveMemoryWarning];
    // Dispose of any resources that can be recreated.
}

- (IBAction)BOpen:(UIButton *)sender
{
    //self.rootvc = [self.storyboard instantiateViewControllerWithIdentifier:@"ROOT"];
    [self BStop:nil];
    
    if (!self.flvc.streammode)
    {
        PLAY_CloseFile(0);
    }
    else
    {
        PLAY_CloseStream(0);
    }
    
    [self.rootvc changeVC:1];
}

- (IBAction)BPlay:(UIButton *)sender {
    PLAY_Play(0, (__bridge HWND)view2);
    self.speed = 1;
    self.label_speed.text = [NSString stringWithFormat:@"%d", self.speed];
    PLAY_PlaySound(0);
    
    if(self.state == state_play_open)
    {
        if(self.flvc.streammode)
        {
            self.thread_inputdata = [[NSThread alloc] initWithTarget:self selector:@selector(run) object:NULL];
            [self.thread_inputdata start];
        }
        
        self.state = state_play_play;
    }
    
    int nbright,ncontrast, nsaturation,nhue;
    PLAY_GetColor(0,0,&nbright,&ncontrast, &nsaturation,&nhue);
    self.slider_bright.value = nbright;
    self.slider_contrast.value = ncontrast;
    self.slider_saturation.value = nsaturation;
    self.slider_hue.value = nhue;
}

- (IBAction)BStop:(UIButton *)sender {
    PLAY_CleanScreen(0, 0, 0, 0, 0, 0);
    PLAY_Stop(0);
    PLAY_SetEngine(0, DECODE_SW, RENDER_NONE);
    
    if (self.flvc.streammode)
    {
        [self.thread_inputdata cancel];
    }
    
    [self.bt_hw setTitle:@"HW:No" forState:UIControlStateNormal];
    self.is_hw = FALSE;
    self.state = state_play_open;
    self.speed = 1;
    self.label_speed.text = [NSString stringWithFormat:@"%d", self.speed];
    
    self.label_Brightness.hidden = true;
    self.label_Contrast.hidden = true;
    self.label_Saturation.hidden = true;
    self.label_Hue.hidden = true;
    self.slider_bright.hidden = true;
    self.slider_contrast.hidden = true;
    self.slider_saturation.hidden = true;
    self.slider_hue.hidden = true;
}

- (IBAction)BClose:(UIButton *)sender {
    PLAY_CloseFile(0);
}

-(IBAction)timercb:(id)sender
{
    self.slider_process.value = (int)(PLAY_GetPlayPos(0)*100);
    //self.pv.progress = PLAY_GetPlayPos(0);
    //[self.aa setProgress:self.aa]
    //NSLog(@"changed %f", PLAY_GetPlayPos(0));
    
    long width = 0;
    long height = 0;
    PLAY_GetPictureSize(0, &width, &height);
    
    NSString* str = [NSString stringWithFormat:@"%d*%d   %4d   %4d/%d   %4d/%d", width,height, PLAY_GetCurrentFrameRate(0),PLAY_GetCurrentFrameNum(0), PLAY_GetFileTotalFrames(0) - 1, PLAY_GetPlayedTime(0), PLAY_GetFileTime(0)];

    self.stateLabel.text = str;
}

- (IBAction)on_bt_hw_press:(UIButton *)sender {
    if(self.state == state_play_open)
    {
        if(self.is_hw == FALSE)
        {
            if(PLAY_SetEngine(0, DECODE_HW, RENDER_NONE))
            {
                [self.bt_hw setTitle:@"HW:Yes" forState:UIControlStateNormal];
                self.is_hw = TRUE;
            }
        }
        else
        {
            PLAY_SetEngine(0, DECODE_SW, RENDER_NONE);
            [self.bt_hw setTitle:@"HW:No" forState:UIControlStateNormal];
            self.is_hw = FALSE;
        }
    }
}

- (IBAction)on_slider_value_changed:(UISlider *)sender {
    NSLog(@"slider %f", self.slider_process.value);
    PLAY_SetPlayPos(0, self.slider_process.value/100.0);
    //PLAY_SetVolume(0, (int)sender.value);
}

- (IBAction)on_bt_slow_press:(UIButton *)sender {
    if(self.state == state_play_play)
    {
        if(self.speed > -64)
        {
            PLAY_Slow(0);
            
            if(self.speed > -64 && self.speed <= -2)
            {
                self.speed *= 2;
            }
            else if(self.speed == 1)
            {
                self.speed = -2;
            }
            else
            {
                self.speed /= 2;
            }
            
            self.label_speed.text = [NSString stringWithFormat:@"%d", self.speed];
        }
    }
}

- (IBAction)on_bt_fast_press:(id)sender {
    if(self.state == state_play_play)
    {
        if(self.speed < 64)
        {
            PLAY_Fast(0);
            
            if(self.speed >= -64 && self.speed < -2)
            {
                self.speed /= 2;
            }
            else if(self.speed == -2)
            {
                self.speed = 1;
            }
            else
            {
                self.speed *= 2;
            }
            
            self.label_speed.text = [NSString stringWithFormat:@"%d", self.speed];
        }
    }
}

- (IBAction)on_bt_pause_press:(UIButton *)sender {
    if(self.state == state_play_play)
    PLAY_Pause(0, TRUE);
}

void AudioRecord(LPBYTE pDataBuffer, DWORD DataLength, void* pUserData)
{
    //NSLog(@" Enter AudioRecord:%d",DataLength);
    
    NSArray * paths = NSSearchPathForDirectoriesInDomains(NSDocumentDirectory, NSUserDomainMask, YES);
    NSString * documentDirectory = [paths objectAtIndex:0];
    NSString * file = [documentDirectory stringByAppendingPathComponent:record_file_name];
    //NSString* temp = @"abc14";
    //NSString * file = [documentDirectory stringByAppendingPathComponent:temp];
    const char* filename = [file UTF8String];

    FILE* p = fopen(filename,"ab+");
    if (p)
    {
        fwrite(pDataBuffer, 1, DataLength, p);
        fclose(p);
    }
}

- (IBAction)on_bt_record_press:(UIButton *)sender {
    if(self.is_bt_record_on)
    {
        [self.bt_record setBackgroundImage:[UIImage imageNamed:@"Image_record_voice_no"] forState:UIControlStateNormal];
        
        PLAY_CloseAudioRecord();
        
        UIAlertView* alert = [[UIAlertView alloc] initWithTitle:@"Audio record success" message:[NSString stringWithFormat:@"Audio file name is %@", record_file_name] delegate:self cancelButtonTitle:@"ok" otherButtonTitles:nil, nil];
        
        [alert show];
        
        self.is_bt_record_on = FALSE;
    }
    else
    {
        [self.bt_record setBackgroundImage:[UIImage imageNamed:@"Image_record_voice"] forState:UIControlStateNormal];
        
        record_file_name = [NSString stringWithFormat:@"%@.pcm",[self ct]];
        
        NSLog(@"rname");
        NSLog(record_file_name);
        
        PLAY_OpenAudioRecord(AudioRecord, 16, 8000, 8000*16/8, 0, 0);
        
        self.is_bt_record_on = TRUE;
    }
}

- (IBAction)on_snappic:(id)sender
{
    if(self.state == state_play_play)
    {
        NSArray * paths = NSSearchPathForDirectoriesInDomains(NSDocumentDirectory, NSUserDomainMask, YES);
        NSString * documentDirectory = [paths objectAtIndex:0];
        NSString* fn = [self ct];
        NSString * file = [documentDirectory stringByAppendingPathComponent:[NSString stringWithFormat:@"%@.bmp", fn]];
        const char* filename = [file UTF8String];
        NSLog(file);
        
        PLAY_CatchPic(0, filename);
        
        UIAlertView* alert = [[UIAlertView alloc] initWithTitle:@"Snap picture success" message:[NSString stringWithFormat:@"Picture name is %@", [NSString stringWithFormat:@"%@.bmp", [self ct]]] delegate:self cancelButtonTitle:@"ok" otherButtonTitles:nil, nil];
        
        [alert show];
    }
}

- (void) run
{
    NSArray * paths = NSSearchPathForDirectoriesInDomains(NSDocumentDirectory, NSUserDomainMask, YES);
    NSString* documentDirectory = [paths objectAtIndex:0];
    NSString* file = [documentDirectory stringByAppendingPathComponent:self.flvc.filename];
    
    const char* filename = [file UTF8String];
    FILE* pfile = fopen(filename, "rb");
    if (!pfile)
    {
        return;
    }
    
    int readlen = 0;
    int ret = 0;
#define READ_SIZE 32*1024
    
    unsigned char buf[READ_SIZE] = {0};
    readlen = fread(buf, 1, 941, pfile);
    PLAY_InputData(0, buf,941);
    
    readlen = fread(buf, 1, 11520, pfile);
    PLAY_InputData(0, buf,11520);
    
    readlen = fread(buf, 1, 3840, pfile);
    PLAY_InputData(0, buf,3840);
    
    readlen = fread(buf, 1, 15360, pfile);
    PLAY_InputData(0, buf,15360);
    
    
    while ((readlen = fread(buf, 1, READ_SIZE, pfile)) > 0 && self.state == state_play_play)
    {
        if([[NSThread currentThread] isCancelled])
        {
            [NSThread exit];
        }
        
        ret = PLAY_InputData(0, buf, readlen);
        while(ret == 0)
        {
            usleep(2*1000);
            ret = PLAY_InputData(0, buf, readlen);
        }
        
        NSLog(@"PLAY_InputData:%d", ret);
        
    }
    
    fclose(pfile);
}

- (NSArray*)getFilenamelistofType:(NSString*)type fromDirPath:(NSString*)dirPath
{
    NSFileManager *fileManager = [[NSFileManager defaultManager] init];
    NSMutableArray *filenamelist = [NSMutableArray arrayWithCapacity:20];
    
    
    NSArray *tmplist = [fileManager contentsOfDirectoryAtPath:dirPath error:nil];
    
    for (NSString *fileName in tmplist)
    {
        NSString* fullpath = [dirPath stringByAppendingPathComponent:fileName];
        if([fileManager fileExistsAtPath:fullpath])
        {
            NSLog(@"here !!! %@ %d", [fileName pathExtension], [[fileName pathExtension] isEqualToString:@"dav"]);
            
            NSRange nn = [type rangeOfString:[fileName pathExtension]];
            if(nn.location != NSNotFound)
                //if ([[fileName pathExtension] isEqualToString:type])
            {
                NSLog(@"%@", fileName);
                [filenamelist addObject:fileName];
            }
            
        }
    }
    
    //[filenamelist addObject:@"Cancel"];
    
    return filenamelist;
}

-(void)run_pressure
{
    NSLog(@"run_pressure start");
    
    NSArray * paths = NSSearchPathForDirectoriesInDomains(NSDocumentDirectory, NSUserDomainMask, YES);
    NSString* documentDirectory = [paths objectAtIndex:0];
    
    NSArray* listData = [self getFilenamelistofType:@"dav mp4 avi" fromDirPath:documentDirectory];
    
    int i = 0;
    while(1)
    {
        for (NSString *fileName in listData)
        {
            NSString* file = [documentDirectory stringByAppendingPathComponent:fileName];
            
            PLAY_OpenFile(i, [file UTF8String]);
            
            PLAY_SetEngine(i, DECODE_HW, RENDER_NONE);
            
            PLAY_Play(i, (__bridge HWND)view2);
            
            PLAY_Fast(i);
            PLAY_Fast(i);
            
            sleep(5);
            
            PLAY_CleanScreen(i, 0, 0, 0, 0, 0);
            
            PLAY_Stop(i);

            PLAY_CloseFile(i);
            i++;
            
            sleep(2);
        }
    }

    NSLog(@"run_pressure stop");
}

-(void)willAnimateRotationToInterfaceOrientation:(UIInterfaceOrientation)toInterfaceOrientation duration:(NSTimeInterval)duration
{
    CGRect b = self.view.bounds;
    if(!UIInterfaceOrientationIsPortrait(toInterfaceOrientation))
    {
        view2.frame = CGRectMake(0, 0, b.size.height, b.size.width);
    }
    else
    {
        view2.frame = CGRectMake(0, self.pt.frame.origin.y + self.pt.frame.size.height, b.size.width, b.size.width*3/4);
    }
}

-(NSUInteger)supportedInterfaceOrientations
{
    if(self.state != state_play_play)
    {
        return UIInterfaceOrientationMaskPortrait;
    }
    else
    {
        return (UIInterfaceOrientationMaskPortrait | UIInterfaceOrientationMaskLandscapeRight);
    }
}

- (IBAction)on_pressure_press:(id)sender
{
    self.thread_pressure = [[NSThread alloc] initWithTarget:self selector:@selector(run_pressure) object:NULL];
    [self.thread_pressure start];
}

- (IBAction)on_bright_valuechanged:(id)sender {
    NSLog(@"bright change");
    int nbright,ncontrast, nsaturation,nhue;
    PLAY_GetColor(0,0,&nbright,&ncontrast, &nsaturation,&nhue);
    PLAY_SetColor(0, 0, self.slider_bright.value, ncontrast, nsaturation,nhue);
    
}

- (IBAction)on_bt_config:(id)sender {
    NSLog(@"bt config");
    self.label_Brightness.hidden = !self.label_Brightness.hidden;
    self.label_Contrast.hidden = !self.label_Contrast.hidden;
    self.label_Saturation.hidden = !self.label_Saturation.hidden;
    self.label_Hue.hidden = !self.label_Hue.hidden;
    self.slider_bright.hidden = !self.slider_bright.hidden ;
    self.slider_contrast.hidden = !self.slider_contrast.hidden ;
    self.slider_saturation.hidden = !self.slider_saturation.hidden ;
    self.slider_hue.hidden = !self.slider_hue.hidden ;
}
- (IBAction)on_slider_contrast:(id)sender {
    NSLog(@"contrast change");
    int nbright,ncontrast, nsaturation,nhue;
    PLAY_GetColor(0,0,&nbright,&ncontrast, &nsaturation,&nhue);
    PLAY_SetColor(0, 0, nbright,self.slider_contrast.value,  nsaturation,nhue);
}

- (IBAction)on_slider_saturation:(id)sender {
    NSLog(@"saturation change");
    int nbright,ncontrast, nsaturation,nhue;
    PLAY_GetColor(0,0,&nbright,&ncontrast, &nsaturation,&nhue);
    PLAY_SetColor(0, 0, nbright,ncontrast,self.slider_saturation.value,nhue);
    
}
- (IBAction)on_slider_hue:(id)sender {
    NSLog(@"hue change");
    int nbright,ncontrast, nsaturation,nhue;
    PLAY_GetColor(0,0,&nbright,&ncontrast, &nsaturation,&nhue);
    PLAY_SetColor(0, 0, nbright,ncontrast,nsaturation,self.slider_hue.value);
}
@end


@implementation MySlider
-(id)initWithFrame:(CGRect)frame
{
    self = [super initWithFrame:frame];
    
    return self;
}

-(void)touchesBegan:(NSSet *)touches withEvent:(UIEvent *)event {
    CGRect t = [self trackRectForBounds: [self bounds]];
    float v = [self minimumValue] + ([[touches anyObject] locationInView: self].x - t.origin.x - 4.0) * (([self maximumValue]-[self minimumValue]) / (t.size.width - 8.0));
    [self setValue: v];
    [super touchesBegan: touches withEvent: event];
    
    NSLog(@"bbbbbbbbbb");
    [self.h on_slider_value_changed:0];
}

-(void) setHP:(ViewController*) h
{
    self.h = h;
}

@end
