/************************************************************************/
/* dhplay   汾:  3.34			                                    */
/************************************************************************/

#ifndef _DHPLAY_H
#define _DHPLAY_H

#if (defined(WIN32) || defined(WIN64))
	#ifdef dhplay_EXPORTS
		#define PLAYSDK_API __declspec(dllexport)
	#else
		#define PLAYSDK_API __declspec(dllimport)
	#endif
	#define CALLMETHOD __stdcall
	#define CALLBACK   __stdcall
#else
	#define CALLMETHOD
	#define CALLBACK
	#define PLAYSDK_API //extern "C"
#endif

#if defined(WIN32) || defined(WIN64)
#include <windows.h>
#else
#ifdef __OBJC__
#include "objc/objc.h"
#else
#define BOOL        int
#endif
#define BYTE		unsigned char
#define PBYTE		BYTE*
#define LPBYTE		BYTE*
#ifndef LONG
#define LONG		int
#endif
#ifndef DWORD
#define DWORD		unsigned int
#endif
#define WORD		unsigned short
#define COLORREF	DWORD
#define HDC			void*
#define HWND		void*
#define LPSTR		char*
#define UINT		unsigned int
#define TRUE		1
#define FALSE		0
#define ULONGLONG	unsigned long long
#define LONGLONG	long long

typedef struct _SYSTEMTIME
{
    WORD wYear;
    WORD wMonth;
    WORD wDayOfWeek;
    WORD wDay;
    WORD wHour;
    WORD wMinute;
    WORD wSecond;
    WORD wMilliseconds;
} SYSTEMTIME, *PSYSTEMTIME, *LPSYSTEMTIME;

#endif

typedef struct _tagRECT
{
	LONG left;
	LONG top;
	LONG right;
	LONG bottom;
}DISPLAYRECT;

#ifdef	__cplusplus
extern "C" {
#endif

/************************************************************************/
/* 궨			                                                    */
/************************************************************************/

#define  FUNC_MAX_PORT					501		//ͨ

#define MIN_WAVE_COEF					-100	//PLAY_AdjustWaveAudioʹ
#define MAX_WAVE_COEF					100		//PLAY_AdjustWaveAudioʹ

#define TIMER_1							1		//ý嶨ʱ
#define TIMER_2							2		//̶߳ʱ

#define BUF_VIDEO_SRC					1		//ƵԴ
#define BUF_AUDIO_SRC					2		//ƵԴ
#define BUF_VIDEO_RENDER				3		//Ƶݻ
#define BUF_AUDIO_RENDER				4		//Ƶݻ

#define MAX_DISPLAY_WND					4

#define DISPLAY_NORMAL					1		//ֱʾ
#define DISPLAY_QUARTER					2		//1/4ֱʾ

#define MAX_DIS_FRAMES					50		//Ż󻺳֡
#define MIN_DIS_FRAMES					6		//ŻС֡

#define BY_FRAMENUM						1		//֡ŷʽ(PLAY_GetKeyFramePosʹ)
#define BY_FRAMETIME					2		//ʱ䷽ʽ(PLAY_GetKeyFramePosʹ)

#define SOURCE_BUF_MAX					1024*100000	//󳤶
#define SOURCE_BUF_MIN					1024*50		//С

#define STREAME_REALTIME				0		//ʵʱģʽ
#define STREAME_FILE					1		//ļģʽ

#define T_AUDIO16						101		//16λƵ
#define T_AUDIO8						100		//8λƵ

#define T_UYVY							1		//UYVY͵YUV,ڲ֧.
#define T_IYUV							3		//IYUV(I420)YUV
#define T_RGB32							7		//RGB32

#define SUPPORT_DDRAW					1		//֧DIRECTDRAW,֧,򲥷ܹ
#define SUPPORT_BLT						2		//Կ֧BLT,֧,򲥷ܹ
#define SUPPORT_BLTFOURCC				4		//ԿBLT֧ɫת,֧,ʹʽRGBת
#define SUPPORT_BLTSHRINKX				8		//ԿBLT֧XС,֧,ϵͳʹʽת
#define SUPPORT_BLTSHRINKY				16		//ԿBLT֧YС,֧,ϵͳʹʽת
#define SUPPORT_BLTSTRETCHX				32		//ԿBLT֧XŴ,֧,ϵͳʹʽת
#define SUPPORT_BLTSTRETCHY				64		//ԿBLT֧YŴ,֧,ϵͳʹʽת
#define SUPPORT_SSE						128		//CPU֧SSEָ,Intel Pentium3֧SSEָ
#define SUPPORT_MMX						256		//CPU֧MMXָ

#define PLAY_CMD_GetTime				1		//ʱϢ
#define PLAY_CMD_GetFileRate			2		//֡Ϣ
#define PLAY_CMD_GetMediaInfo			3		//ýϢ
#define PLAY_CMD_GetRenderNum			4		//ǰҪȾ֡
#define PLAY_CMD_GetRenderTime			5		//ǰҪȾʱ
#define PLAY_CMD_GetSrcTime				6

#define AVI_MEDIACHANGE_FRAMERATE		1		//֡ʸı
#define AVI_MEDIACHANGE_RESOLUTION		2		//ֱʸı

#define WATERMARK_DATA_TEXT				0		//
#define WATERMARK_DATA_JPEG_BMP			1		//JPEGBMPͼƬ
#define WATERMARK_DATA_FRAMEDATA		3		//֡

#define	DH_PLAY_NOERROR					0		//ûд
#define DH_PLAY_PARA_OVER				1		//Ƿ
#define DH_PLAY_ORDER_ERROR				2		//˳򲻶
#define DH_PLAY_TIMER_ERROR				3		//ýʱʧ
#define DH_PLAY_DEC_VIDEO_ERROR			4		//Ƶʧ
#define DH_PLAY_DEC_AUDIO_ERROR			5		//Ƶʧ
#define DH_PLAY_ALLOC_MEMORY_ERROR		6		//ڴʧ
#define DH_PLAY_OPEN_FILE_ERROR			7		//ļʧ
#define DH_PLAY_CREATE_OBJ_ERROR		8		//߳¼ʧ
#define DH_PLAY_CREATE_DDRAW_ERROR		9		//directDrawʧ
#define DH_PLAY_CREATE_OFFSCREEN_ERROR	10		//˻ʧ
#define DH_PLAY_BUF_OVER				11		//,ʧ
#define DH_PLAY_CREATE_SOUND_ERROR		12		//Ƶ豸ʧ
#define DH_PLAY_SET_VOLUME_ERROR		13		//ʧ
#define DH_PLAY_SUPPORT_FILE_ONLY		14		//ֻڲļʱʹ
#define DH_PLAY_SUPPORT_STREAM_ONLY		15		//ֻڲʱʹ
#define DH_PLAY_SYS_NOT_SUPPORT			16		//ϵͳ֧,ֻܹPentium 3
#define DH_PLAY_FILEHEADER_UNKNOWN		17		//ûļͷ
#define DH_PLAY_VERSION_INCORRECT		18		//ͱ汾Ӧ
#define DH_PLAY_INIT_DECODER_ERROR		19		//ʼʧ
#define DH_PLAY_CHECK_FILE_ERROR		20		//ļ̫̻޷ʶ
#define DH_PLAY_INIT_TIMER_ERROR		21		//ʼýʱʧ
#define DH_PLAY_BLT_ERROR				22		//λʧ
#define DH_PLAY_UPDATE_ERROR			23		//ʾoverlayʧ
#define DH_PLAY_MEMORY_TOOSMALL			24		//̫С


// SVAC궨
//SVC  flags
#define SVC_LAYER_BASE    0x0001
#define SVC_LAYER_ENHANCE 0x0002

#define MAX_CUSTOM_EXT_COUNT            8
#define MAX_EXT_ROI_REGION_NUM          32  //ROIչĸ    //׼Эû涨ֵǶ٣ݶΪ32Ӧù
#define MAX_EXT_EVENT_REGION_NUM        32  //¼չĸ
#define MAX_EXT_ALERT_NUM               32  //رչĸ

//չݵ
#define EXT_TYPE_ROI        0x0001      //ROIչ
#define EXT_TYPE_TIME       0x0002      //ʱչ
#define EXT_TYPE_ALERT      0x0004      //չ
#define EXT_TYPE_EVENT      0x0008      //¼չ
#define EXT_TYPE_AUTH       0x0010      //֤
#define EXT_TYPE_CUSTOM     0x1000      //Զչ


/************************************************************************/
/* ṹ	                                                            */
/************************************************************************/

typedef enum __tPicFormats
{
	PicFormat_BMP = 0,				        //BMP32
    PicFormat_JPEG,							//JPEG
	PicFormat_JPEG_70,						//70%JPEG
	PicFormat_JPEG_50,						//50%JPEG
	PicFormat_JPEG_30,						//30%JPEG
	PicFormat_JPEG_10,						//10%JPEG
	PicFormat_BMP24,                        //BMP24
	PicFormat_TIFF							//TIFF
} tPicFormats;

typedef struct
{
	LONGLONG		nFilePos;				//ָ֡ļеƫλ
	LONG			nFrameLen;				//֡
	LONG			nFrameNum;				//֡
	LONG			nFrameTime;				//֡ʱ
	LONG			nErrorFrameNum;			//,ʹ
	SYSTEMTIME*		pErrorTime;				//,ʹ
	LONG			nErrorLostFrameNum;		//,ʹ
	LONG			nErrorFrameSize;		//,ʹ
}FRAME_POS,*PFRAME_POS;

typedef struct
{
	LONG			nWidth;					//,λ.ƵΪ0.
	LONG			nHeight;				//,ƵΪ0
	LONG			nStamp;					//ʱϢ,λ
	LONG			nType;					//Ƶ֡,T_AUDIO16,T_RGB32,T_IYUV
	LONG			nFrameRate;				//ʱͼ֡
}FRAME_INFO;

typedef struct
{
	#define FRAME_TYPE_VIDEO 0				//Ƶ֡
	#define FRAME_TYPE_AUDIO 1				//Ƶ֡
	int				nFrameType;				//Ƶ֡,涨
	int				nFrameSeq;				//֡
	int				nStamp;					//ʱϢ,λ
	int				nWidth;					//,λ.ƵΪ0.
	int 			nHeight;				//,ƵΪ0
	int				nFrameRate;				//ʱͼ֡
	int				nChannels;				//Ƶͨ
	int				nBitPerSample;			//Ƶλ
	int				nSamplesPerSec;			//ƵƵ
	int				nRemainData;			//ʣ
	SYSTEMTIME		nDataTime;				//ʱ
	int				nReserved[59];			//ֶ
}FRAME_INFO_EX;

typedef struct 
{
	int				nFrameType;					//֡,FRAME_INFO_EXnFrameTypeֶ
	
	void*			pAudioData;				//Ƶ,Ƶ֡
	int				nAudioDataLen;			//Ƶݳ

	void*			pVideoData[3];			//ֱʾƵYUV
	int				nStride[3];				//ֱʾYUVĿ
	int				nWidth[3];				//ֱʾYUVĿ
	int				nHeight[3];				//ֱʾYUVĸ߶
	int				nReserved[64];			//ֶ
}FRAME_DECODE_INFO;

typedef struct 
{
	int			lWidth;					//,λ.
	int			lHeight;				//
	int			lFrameRate;				//֡
	int			lChannel;				//Ƶͨ
	int			lBitPerSample;			//Ƶλ
	int			lSamplesPerSec;			//ƵƵ
}MEDIA_INFO;

typedef struct 
{
	char*			pDataBuf;				//֡
	LONG			nSize;					//֡ݳ
	LONG			nFrameNum;				//֡
	BOOL			bIsAudio;				//ǷƵ֡
	LONG			nReserved;				//
}FRAME_TYPE;



// 븽Ϣ
typedef struct
{
    LONG			nVideoEncodeType;   // 
    LONG	        nDataLen;           // ݳ
    char*           pUserData;              // Ϣ
    LONG	        nReserved[2];
}FRAME_DEC_EXT_INFO;

// SVAC븽ϢԶֶ
typedef struct
{
    unsigned char type;             // Ϣ
    unsigned char length;           // Ϣ
    unsigned char *pbuf;            // Ϣָ
    unsigned char reserved[2];      // 
}DEC_EXT_INFO_CUSTOM;

typedef struct
{
    int flags;                              //չͱ

    int time_year;                          //ʱչ
    int time_month;
    int time_day;
    int time_hour;
    int time_minute;
    int time_second;
    int time_sec_fractional;
    int time_frame_num;

    int roi_region_num;                             // ROIչ
    int roi_top_left_x[MAX_EXT_ROI_REGION_NUM];     // ROIϽx
    int roi_top_left_y[MAX_EXT_ROI_REGION_NUM];     // ROIϽy
    int roi_width[MAX_EXT_ROI_REGION_NUM];          // ROI
    int roi_height[MAX_EXT_ROI_REGION_NUM];         // ROI߶

    int event_region_num;                           // ¼չ
    int event_num[MAX_EXT_EVENT_REGION_NUM];
    int event_region_event_id[MAX_EXT_EVENT_REGION_NUM][16];

    int alert_num;                                  // رչ
    int alert_region_id[MAX_EXT_ALERT_NUM];
    int alert_event_id[MAX_EXT_ALERT_NUM];
    int alert_frame_num[MAX_EXT_ALERT_NUM];

    //֤ز
    int *auth_buf[2];                               // ֤buf, auth_buf[0]ǻ֤, auth_buf[1]ǿ֤
    int auth_len[2];                                // ֤ݳ, ֤ʱӦΪ 0
    int auth_signature_type[2];
    int auth_hash_hierarchy_flag[2];

    DEC_EXT_INFO_CUSTOM svac_ext_info_custom[MAX_CUSTOM_EXT_COUNT];     // չ
}DEC_EXT_PARAM_SVAC;

/***begin۶***/
typedef enum
{
	FISHEYEMOUNT_MODE_INVALID = 0,
	FISHEYEMOUNT_MODE_CEIL = 1,						/*װ*/
	FISHEYEMOUNT_MODE_WALL,							/*װ*/
	FISHEYEMOUNT_MODE_FLOOR,						/*װ*/
	FISHEYEMOUNT_MODE_NUM
}FISHEYE_MOUNTMODE;

typedef enum
{
	FISHEYECALIBRATE_MODE_INVALID = 0,
	FISHEYECALIBRATE_MODE_OFF = 1,								/*ر㷨⣬ⲿر*/
	FISHEYECALIBRATE_MODE_ORIGINAL,								/*ԭʼģʽ(),ű*/
	FISHEYECALIBRATE_MODE_PANORAMA,								/*1p*/
	FISHEYECALIBRATE_MODE_PANORAMA_PLUS_ONE_EPTZ,				/*1p+1*/
	FISHEYECALIBRATE_MODE_DOUBLE_PANORAMA,						/*2p*/
	FISHEYECALIBRATE_MODE_ORIGINAL_PLUS_DOUBLE_PANORAMA,		/*1+2p*/
	FISHEYECALIBRATE_MODE_ORIGINAL_PLUS_THREE_EPTZ_REGION,		/*1+3*/
	FISHEYECALIBRATE_MODE_PANORAMA_PLUS_THREE_EPTZ_REGION,		/*1p+3*/
	FISHEYECALIBRATE_MODE_ORIGINAL_PLUS_TWO_EPTZ_REGION,		/*1+2*/	
	FISHEYECALIBRATE_MODE_ORIGINAL_PLUS_FOUR_EPTZ_REGION,		/*1+4*/
	FISHEYECALIBRATE_MODE_PANORAMA_PLUS_FOUR_EPTZ_REGION,		/*1p+4*/
	FISHEYECALIBRATE_MODE_PANORAMA_PLUS_SIX_EPTZ_REGION,		/*1p+6*/
	FISHEYECALIBRATE_MODE_ORIGINAL_PLUS_EIGHT_EPTZ_REGION,		/*1+8*/
	FISHEYECALIBRATE_MODE_PANORAMA_PLUS_EIGHT_EPTZ_REGION,		/*1p+8*/
	FISHEYECALIBRATE_MODE_TWO_EPTZ_REGION_WITH_ORIGINAL,		/*1F+2*/	
	FISHEYECALIBRATE_MODE_FOUR_EPTZ_REGION_WITH_ORIGINAL,		/*1F+4*/	
	FISHEYECALIBRATE_MODE_DOUBLE_PANORAMA_WITH_ORIGINAL,		/*1F+2p*/
	FISHEYECALIBRATE_MODE_FOUR_EPTZ_REGION_WITH_PANORAMA,		/*1p(F)+4*/
	FISHEYECALIBRATE_MODE_TWO_EPTZ_REGION,		                /*2*/
	FISHEYECALIBRATE_MODE_SINGLE,								/**/
	FISHEYECALIBRATE_MODE_FOUR_EPTZ_REGION,						/*4*/
	FISHEYECALIBRATE_MODE_USER_DEFINED,				    		/*ûԶ*/
	FISHEYECALIBRATE_MODE_PHONE,								/*ֻģʽ*/
	FISHEYECALIBRATE_MODE_ORIGINAL_PLUS_ONE_EPTZ_REGION,		/*1+1*/
	FISHEYECALIBRATE_MODE_ONE_EPTZ_REGION,						/*1*/

	FISHEYECALIBRATE_MODE_NUM
}FISHEYE_CALIBRATMODE;

typedef enum
{
	FISHEYEEPTZ_CMD_INVALID = 0,	
	FISHEYEEPTZ_CMD_ZOOM_IN = 1,						/*Ŵ*/
	FISHEYEEPTZ_CMD_ZOOM_OUT,							/*С*/
	FISHEYEEPTZ_CMD_UP,									/*ƶ*/
	FISHEYEEPTZ_CMD_DOWN,								/*ƶ*/
	FISHEYEEPTZ_CMD_LEFT,								/*ƶ*/
	FISHEYEEPTZ_CMD_RIGHT,								/*ƶ*/
	FISHEYEEPTZ_CMD_ROTATE_CLOCKWISE_AUTO,				/*Զ˳ʱת*/
	FISHEYEEPTZ_CMD_ROTATE_ANTICLOCKWISE_AUTO,			/*Զʱת*/
	FISHEYEEPTZ_CMD_STOP,								/*ֹͣ*/
	FISHEYEEPTZ_CMD_SHOW_REGION,						/*ѡŴ*/
	FISHEYEEPTZ_CMD_EXIT_SHOW_REGION,					/*˳ѡŴ*/
	FISHEYEEPTZ_CMD_DEFAULT,						    /*ָĬ*/
	FISHEYEEPTZ_CMD_ORIGIN_ROTATE,						/*Բת*/

	FISHEYEEPTZ_CMD_SET_CUR_REGION = 0x20,             /*ָڵλϢ*/
	FISHEYEEPTZ_CMD_GET_CUR_REGION,                    /*ȡָڵλϢ*/
	FISHEYEEPTZ_CMD_IS_IN_PANORAMA_REGION,             /*Ƿڵǰȫ*/
	FISHEYEEPTZ_CMD_TAP_VIEW,							/*ʾָλ,㼴*/
	FISHEYEEPTZ_CMD_SET_FOCUS,	 				        /*ôλϢ*/
	FISHEYEEPTZ_CMD_GET_FOCUS,							/*ȡλϢ*/

	FISHEYEEPTZ_CMD_PTZ_CALI,							/*궨*/
	FISHEYEEPTZ_CMD_GET_PTZ_RLT,						/*ȡλϢ*/
	FISHEYEEPTZ_CMD_NUM
}FISHEYE_EPTZCMD;

typedef struct
{
	int w;
	int h;
}FISHEYE_SIZE;

typedef struct
{
	short x;
	short y;
}FISHEYE_POINT2D;

typedef struct
{
	FISHEYE_MOUNTMODE     subMountMode;			    /*ͼװģʽ, ͼУģʽΪûԶģʽʱ, ֵЧ*/
	FISHEYE_CALIBRATMODE  subCalibrateMode;	        /*ͼУģʽ, ͼУģʽΪûԶģʽʱ, ֵЧ*/
	FISHEYE_SIZE          imgOutput;                /*ͼֱ*/
	FISHEYE_POINT2D       upperLeft;                /*ͼƫ*/
	int					  reserved[3];				/*ֽ*/
}FISHEYE_SUBMODE;

typedef struct
{
	FISHEYE_SIZE          mainShowSize;		        /*ݲ, ʾ, 4:3, 16:9, 㷨ݴʺϵŽ¾ﵽñ*/
	FISHEYE_SIZE          floatMainShowSize;		/*˫bufferʱʹãĿǰʱϵĲڵʾڷֱ, ԲĿ߱ҪΪ1:1װȫĿ߱ҪΪ16:9*/
	FISHEYE_SIZE          imgOutput;                /*ͼֱ(ǰ), ͼУģʽΪûԶģʽʱΪⲿ, ģʽΪڲ*/
	FISHEYE_SUBMODE*	  subMode;                  /*ģʽϢ, ͼУģʽΪûԶģʽʱΪⲿ, ģʽΪڲ*/
	int		              subModeNum;               /*ģʽ, ͼУģʽΪûԶģʽʱΪⲿ, ģʽΪڲ*/
	int                   outputSizeRatio;		    /*ݲ, Уͼű,Q8ʽ,Χ0-256, 256Ϊֱ*/
	int                   reserved[1];				/*ֽ*/
}FISHEYE_OUTPUTFORMAT;

typedef struct
{
	int x;
	int y;
	int hAngle;
	int vAngle;
	int available;
	int reserved[3];
}FISHEYE_REGIONPARAM;

typedef struct
{
	FISHEYE_REGIONPARAM   regionParam[9];
	int              circularOffset;
	int              panoramaOffset;
	int              useRegionParam;           /*Ϊ1ʱЧʹøֵгʼûбϢʱΪ0*/
	int              reserved[1];
}FISHEYE_MODEINITPARAM;

/*ǹ*/
typedef enum CAM_TYPE
{
	//ǹ
	IPCTYPE_200WN				= 0,	//
	IPCTYPE_130WN				= 1,
	IPCTYPE_D1WN				= 2,
	IPCTYPE_100WN				= 3,
	IPCTYPE_FE					= 4,	//

	//
	SPCTYPE_D6501				= 100,	//sonyо65
	HSPCTYPE_D6A2030E			= 101,	//󻪻о2030E6A
	HSPCTYPE_D65A2030E			= 102	//󻪻о2030E65A
}CAM_TYPE;

/*ͷ*/
typedef enum LEN_TYPE
{
	LENTYPE_NORM				= 0,	//޻侵ͷ
	LENTYPE_Lens0361 			= 1,	//3.6ǹͷ
	LENTYPE_Lens2880			= 2,	//130ȹǹͷ
	LENTYPE_Lens0362 			= 3,	//3.6ǹͷ
	LENTYPE_Lens0401 			= 4,	//4.0ǹͷ

	LENTYPE_TEST1				= 100	//ò
}LEN_TYPE;

typedef struct
{	
	/**/
	int zoom_type;							//ģʽ----Ӧ䱶͸ݿѡĿС䱶ģʽ
	int hcam_wax;							//ӦǶxˮƽ
	int hcam_way;							//ӦǶyֱ
	int hcam_wmul;							//ã׼
	int cfg_type;							//÷ʽĬΪ1ʹòʽ,1ʹò÷ʽ0ʹ豸÷ʽ

	//							         
	//ͷ
	int prm_re;								//ͶӰ뾶
	int prm_mul;							//ͶӰ
	int prm_dx;								//xƫ
	int prm_dy;								//yƫ
	int prm_cw;								//CMOSʵʹÿ
	int prm_ch;								//CMOSߣʵʹøߣ

	//ʹãcfg_typeΪ0ʱøòЧ            //Ĭ130ȡ130ǹ200W65
	LEN_TYPE mlen_type;						//ͷ
	CAM_TYPE mcam_type;						//
	CAM_TYPE hcam_type;						//

	//
	int himg_width;                         //ͼ
	int himg_height;                        //ͼ
	int prm_fax;                            //ˮƽӳ

	/*ĬϵĲ*/
	//
	int mcam_fc;							//Ч
	int mcam_cw;							//ͷ
	int mcam_ch;							//ͷ 
	int cam_height;                         //߶ȣףʱδʹã
	int prm_ma;								//

	//
	//
	int prm_hw;								//CMOS
	int prm_hh;								//CMOS
	int prm_fo;								//Ч
	int prm_ca;								//Ұ
	int prm_mmul;							//
}MHFPTZ_CONFIGPARAM;

typedef struct
{
	FISHEYE_SIZE     mainStreamSize;		    /*Ӧԭʼߣֱ֮ʱΪǴ˷ֱŶ*/
	int              originX;					/*ͼԲԲĺ, һ0-8192ϵ*/
	int              originY;					/*ͼԲԲ, һ0-8192ϵ*/
	int              radius;					/*ͼԲİ뾶, һ0-8192ϵ*/ 
	int              lensDirection;		        /*תǶ, Q7ʽ, Χ0-360*128, һΪ0*/
	FISHEYE_MOUNTMODE     mainMountMode;		/*װģʽ*/
	FISHEYE_CALIBRATMODE  mainCalibrateMode;	/*ͼУģʽ*/
	FISHEYE_MODEINITPARAM modeInitParam;        /*ⲿģʽʼϢģʽлָһε״̬,*/
	FISHEYE_OUTPUTFORMAT *outputFormat;         /*ͼϢ*/
	MHFPTZ_CONFIGPARAM   *configParam;          /*ò*/
	int              enableAutoContrast;       /*ԶԱȶ, 0ر, 1, ùܻ㷨ʱ, ҪܺõĻŽ鿪*/
	int              alphaHistogram;           /*ֱͼIIRǿ0-255, Ĭ128, ԽԽοǰ֡*/
	int              alphaGray;                /*Ҷǿ0-255, Ĭ245, ԽԽԱȶ*/
	FISHEYE_SIZE     captureSize;		       /*Ӧǰģʽµץͼֱ*/
	int              mhfptzIndex;               //IN 0,1,2....
	int              reserved[1];				/*ֽ*/
}FISHEYE_OPTPARAM;

typedef struct
{
	FISHEYE_EPTZCMD   ePtzCmd;			/*̨˵FISHEYE_EPtzCmd*/
	int          winId;				    /*ҪeptzĴڱţϽwinIdΪ0ҵ*/							
	int          arg1;
	int          arg2;
	int          arg3;
	int          arg4;
	int          arg5;
	int          arg6;
	int          reserved0[6];			   /*ֽ*/
	void*        pParam;                   /**/
	void*        pResult;
	void*        pArg;   

	int          reserved1[7];			   /*ֽ*/

}FISHEYE_EPTZPARAM;

typedef enum
{
	FISHEYE_SETPARAM,
	FISHEYE_GETPARAM

}FISHEYE_OPERATETYPE;
/***end۶***/

/************************************************************************/
/* ӿ		                                                            */
/************************************************************************/

//------------------------------------------------------------------------
// : PLAY_OpenFile
// : 򿪲ļڲļ֮ǰ. ļܳ4GС4K
// : nPort,ͨ
//		 sFileName,ļ
// : BOOL,ɹTRUE,ʧܷFALSE
//------------------------------------------------------------------------
PLAYSDK_API BOOL CALLMETHOD PLAY_OpenFile(LONG nPort,LPSTR sFileName);

//------------------------------------------------------------------------
// : PLAY_CloseFile
// : رļ, PLAY_Stop
// : nPort,ͨ
// : BOOL,ɹTRUE,ʧܷFALSE
//------------------------------------------------------------------------
PLAYSDK_API BOOL CALLMETHOD PLAY_CloseFile(LONG nPort);

//------------------------------------------------------------------------
// : PLAY_OpenStream
// : 
// : nPort,ͨ
//		 pFileHeadBuf,Ŀǰʹ,NULL.
//		 nSize,Ŀǰ,0.
//		 nBufPoolSize,òдĻС.
//			Χ[SOURCE_BUF_MIN,SOURCE_BUF_MAX].һΪ900*1024
//			͹Ծ,ɵСֵ,ݴ䲻,ֵ.
// : BOOL,ɹTRUE,ʧܷFALSE.
//------------------------------------------------------------------------
PLAYSDK_API BOOL CALLMETHOD PLAY_OpenStream(LONG nPort,PBYTE pFileHeadBuf,DWORD nSize,DWORD nBufPoolSize);

//------------------------------------------------------------------------
// : PLAY_CloseStream
// : ر
// : nPort,ͨ
// : BOOL,ɹTRUE,ʧܷFALSE.
//------------------------------------------------------------------------
PLAYSDK_API BOOL CALLMETHOD PLAY_CloseStream(LONG nPort);

//------------------------------------------------------------------------
// : PLAY_Play
// : ʼ.Ѿ,ı䵱ǰ״̬ΪٶȲ.
// : nPort,ͨ
//		 hWnd,Ŵھ
// : BOOL,ɹTRUE,ʧܷFALSE.
//------------------------------------------------------------------------
PLAYSDK_API BOOL CALLMETHOD PLAY_Play(LONG nPort, HWND hWnd);

//------------------------------------------------------------------------
// : PLAY_Stop
// : ֹͣ
// : nPort,ͨ
// : BOOL,ɹTRUE,ʧܷFALSE.
//------------------------------------------------------------------------
PLAYSDK_API BOOL CALLMETHOD PLAY_Stop(LONG nPort);

//------------------------------------------------------------------------
// : PLAY_InputData
// : ,PLAY_Play֮ʹ
// : nPort,ͨ
//		 pBuf,ַ
//		 nSize,С
// : BOOL,ɹTRUE,ʧܷFALSE.ʧ,һǻ,ûͣ
//			룬һʱ֮ȷſⲻʧݡ
//------------------------------------------------------------------------
PLAYSDK_API BOOL CALLMETHOD PLAY_InputData(LONG nPort,PBYTE pBuf,DWORD nSize);

//------------------------------------------------------------------------
// : PLAY_Pause
// : ͣ߻ָ
// : nPort,ͨ
//		 nPause,TRUEͣ,FLASEָ
// : BOOL,ɹTRUE,ʧܷFALSE.
//------------------------------------------------------------------------
PLAYSDK_API BOOL CALLMETHOD PLAY_Pause(LONG nPort,DWORD nPause);

//------------------------------------------------------------------------
// : PLAY_Fast
// : ٶȷΧΪ[1/64, 64]
//		 ÿεòٶһ(*2),Ҫָŵ
//		 PLAY_Play,ӵǰλÿʼ.
// : nPort,ͨ
// : BOOL,ɹTRUE,ʧܷFALSE.
//------------------------------------------------------------------------
PLAYSDK_API BOOL CALLMETHOD PLAY_Fast(LONG nPort);

//------------------------------------------------------------------------
// : PLAY_Slow
// : ٶȷΧΪ[1/64, 64]
//		 ÿεòٶȽһ(*0.5),ҪָŵPLAY_Play.
// : nPort,ͨ
// : BOOL,ɹTRUE,ʧܷFALSE.
//------------------------------------------------------------------------
PLAYSDK_API BOOL CALLMETHOD PLAY_Slow(LONG nPort);

//------------------------------------------------------------------------
// : PLAY_OneByOne
// : 岥,ҪָŵPLAY_ Play.
// : nPort,ͨ
// : BOOL,ɹTRUE,ʧܷFALSE.
//------------------------------------------------------------------------
PLAYSDK_API BOOL CALLMETHOD PLAY_OneByOne(LONG nPort);

//------------------------------------------------------------------------
// : PLAY_SetPlayPos
// : ļָλ(ٷֱ)
// : nPort,ͨ
//		 fRelativePos,ļȵİٷֱ
// : BOOL,ɹTRUE,ʧܷFALSE.
//------------------------------------------------------------------------
PLAYSDK_API BOOL CALLMETHOD PLAY_SetPlayPos(LONG nPort,float fRelativePos);

//------------------------------------------------------------------------
// : PLAY_SetPlayDirection
// : òŷ
// : nPort,ͨ
//		 emDirection,ŷ0ǰ1
// : BOOL,ɹTRUE,ʧܷFALSE.
//------------------------------------------------------------------------
PLAYSDK_API BOOL CALLMETHOD PLAY_SetPlayDirection(LONG nPort, DWORD emDirection);

//------------------------------------------------------------------------
// : PLAY_GetPlayPos
// : ȡļָλ(ٷֱ)
// : nPort,ͨ
// : float,ļȵλ,Χ0-100%
//------------------------------------------------------------------------
PLAYSDK_API float CALLMETHOD PLAY_GetPlayPos(LONG nPort);

//------------------------------------------------------------------------
// : PLAY_SetFileEndMsg
// : ļʱҪ͵Ϣ
// : nPort,˿ں
//       hWnd,Ϣʹ
//       nMsg,ûԶϢŵļʱûhWndڹ
//			յϢϢеwParamlParamԻnPortֵ.
// : BOOL,ɹTRUE,ʧܷFALSE.
//------------------------------------------------------------------------
PLAYSDK_API BOOL CALLMETHOD PLAY_SetFileEndMsg(LONG nPort,HWND hWnd,UINT nMsg);

//------------------------------------------------------------------------
// : PLAY_SetVolume
// : ,õָ,ӰӦ.
// : nPort,ͨ
//		 nVolume,ֵ,Χ[0,0xFFFF]
// : BOOL,ɹTRUE,ʧܷFALSE.
//------------------------------------------------------------------------
PLAYSDK_API BOOL CALLMETHOD PLAY_SetVolume(LONG nPort,WORD nVolume);

//------------------------------------------------------------------------
// : PLAY_StopSound
// : رնռʽ
// : 
// : BOOL,ɹTRUE,ʧܷFALSE.
//------------------------------------------------------------------------
PLAYSDK_API BOOL CALLMETHOD PLAY_StopSound();

//------------------------------------------------------------------------
// : PLAY_PlaySound
// : ռʽ,ͬһʱֻһ·,Ѿ򿪣
//		 ԶرԭѾ򿪵.
// : nPort,ͨ
// : BOOL,ɹTRUE,ʧܷFALSE.
//------------------------------------------------------------------------
PLAYSDK_API BOOL CALLMETHOD PLAY_PlaySound(LONG nPort);

//------------------------------------------------------------------------
// : PLAY_GetFileTime
// : ȡļʱ
// : nPort,ͨ
// : ļܵʱ䳤ֵ,λ.
//------------------------------------------------------------------------
PLAYSDK_API DWORD CALLMETHOD PLAY_GetFileTime(LONG nPort);

//------------------------------------------------------------------------
// : PLAY_GetPlayedTime
// : ȡǰļʱ
// : nPort,ͨ
// : ļǰŵʱ,λ
//------------------------------------------------------------------------
PLAYSDK_API DWORD CALLMETHOD PLAY_GetPlayedTime(LONG nPort);

//------------------------------------------------------------------------
// : PLAY_GetPlayedFrames
// : ȡѲŵ
// : nPort,ͨ
// : ѾƵ֡
//------------------------------------------------------------------------
PLAYSDK_API DWORD CALLMETHOD PLAY_GetPlayedFrames(LONG nPort);

//------------------------------------------------------------------------
// : PLAY_SetDecodeCallBack
// : ýص,滻еʾ,ûԼʾ,ú
//			PLAY_Play֮ǰ,PLAY_StopʱԶʧЧ,´εPLAY_Play֮ǰ
//			Ҫ.벿ֲٶ,ֻҪûӻصз,
//			ͻһ.ֻ벻ʾΡ
// : nPort,ͨ
//		 cbDec,صָ,ΪNULL.ص:
//			nPort,ͨ
//			pFrameDecodeInfo,Ƶ
//			pFrameInfo,ͼϢ,μFRAME_INFOṹ
//			pUser,ûԶ
//		 pUser,ûԶ
// : BOOL,ɹTRUE,ʧܷFALSE.
//------------------------------------------------------------------------
typedef void (CALLBACK* fCBDecode)(LONG nPort, FRAME_DECODE_INFO* pFrameDecodeInfo, FRAME_INFO_EX* pFrameInfo, void* pUser);
PLAYSDK_API BOOL CALLMETHOD PLAY_SetDecodeCallBack(LONG nPort, fCBDecode cbDec, void* pUser);

//------------------------------------------------------------------------
// : PLAY_SetDisplayCallBack
// : Ƶץͼص.Ҫֹͣص,԰ѻصָΪNULL,
//			κʱ
// : nPort,ͨ
//		 DisplayCBFun,ץͼص,ΪNULL,
//			nPort,ͨ
//			pBuf,ͼ
//			nSize,ͼݴС
//			nWidth,,λ
//			nHeight,
//			nStamp,ʱϢλ
//			nType,,T_RGB32,T_UYVY,궨˵
//			nReceaved,ӦûԶ
//		 pUserData,ûԶ
// : BOOL,ɹTRUE,ʧܷFALSE.
//------------------------------------------------------------------------
typedef void (CALLBACK* fDisplayCBFun)(LONG nPort,char * pBuf,LONG nSize,LONG nWidth,LONG nHeight,LONG nStamp,LONG nType, void* pReserved);
PLAYSDK_API BOOL CALLMETHOD PLAY_SetDisplayCallBack(LONG nPort, fDisplayCBFun DisplayCBFun, void* pUserData);

//------------------------------------------------------------------------
// : PLAY_ConvertToBmpFile
// : ͼʽתΪBMPʽ.
// : pBuf,ͼָ
//		 nSize,ͼݴС
//		 nWidth,ͼ
//		 nHeight,ͼ߶
//		 nType,.T_RGB32,T_UYVY.
//		 sFileName,Ҫļ.BMPΪļչ.
// : BOOL,ɹTRUE,ʧܷFALSE.
//------------------------------------------------------------------------
PLAYSDK_API BOOL CALLMETHOD PLAY_ConvertToBmpFile(char * pBuf,LONG nSize,LONG nWidth,LONG nHeight,LONG nType, char *sFileName);

//------------------------------------------------------------------------
// : PLAY_ConvertToJpegFile
// : ͼʽתΪJPEGʽ.
// : pYUVBuf,ͼָ
//		 nWidth,ͼ
//		 nHeight,ͼ߶
//		 YUVtype,YUV,T_YV12,T_UYVY
//		 quality,ͼƬѹ,Χ(0, 100].
// : BOOL,ɹTRUE,ʧܷFALSE.
//------------------------------------------------------------------------
PLAYSDK_API BOOL CALLMETHOD PLAY_ConvertToJpegFile(char *pYUVBuf, LONG nWidth, LONG nHeight, int YUVtype, int quality, char *sFileName);

//------------------------------------------------------------------------
// : PLAY_GetFileTotalFrames
// : ȡļ֡
// : nPort,ͨ
// : DWORD,ļе֡
//------------------------------------------------------------------------
PLAYSDK_API DWORD CALLMETHOD PLAY_GetFileTotalFrames(LONG nPort);

//------------------------------------------------------------------------
// : PLAY_GetCurrentFrameRate
// : ȡǰ֡
// : nPort,ͨ
// : DWORD,ǰбʱֵ֡
//------------------------------------------------------------------------
PLAYSDK_API DWORD CALLMETHOD PLAY_GetCurrentFrameRate(LONG nPort);

//------------------------------------------------------------------------
// : PLAY_GetPlayedTimeEx
// : ȡļǰʱ
// : nPort,ͨ
// : DWORD,ļǰŵʱ,λ.
//------------------------------------------------------------------------
PLAYSDK_API DWORD CALLMETHOD PLAY_GetPlayedTimeEx(LONG nPort);

//------------------------------------------------------------------------
// : PLAY_SetPlayedTimeEx
// : ļǰʱ.
// : nPort,ͨ
//		 nTime,ļλõָʱ,λ.
// : BOOL,ɹTRUE,ʧܷFALSE.
//------------------------------------------------------------------------
PLAYSDK_API BOOL CALLMETHOD PLAY_SetPlayedTimeEx(LONG nPort,DWORD nTime);

//------------------------------------------------------------------------
// : PLAY_GetCurrentFrameNum
// : ȡǰŵ֡,PLAY_GetPlayedFramesܹ֡.ļ
//			λòı䣬ôķֵӦ÷ǳӽ
//			ʧ.
// : nPort,ͨ
// : ǰŵ֡.
//------------------------------------------------------------------------
PLAYSDK_API DWORD CALLMETHOD PLAY_GetCurrentFrameNum(LONG nPort);

//------------------------------------------------------------------------
// : PLAY_SetStreamOpenMode
// : ģʽ,ڲ֮ǰ.
// : nPort,ͨ
//		 nMode,STREAME_REALTIMEʵʱģʽ(Ĭ);STREAME_FILEļģʽ.ʵʱģ
//			ʽ,ʺϲʵʱ;ļģʽ,ʺûļʽ.
// : BOOL,ɹTRUE,ʧܷFALSE.
//------------------------------------------------------------------------
PLAYSDK_API BOOL CALLMETHOD PLAY_SetStreamOpenMode(LONG nPort,DWORD nMode);

//------------------------------------------------------------------------
// : PLAY_GetSdkVersion
// : ȡſSDK汾,ΰ汾źͲ
// : 
// : DWORD,16λʾǰ汾;9~16λʾΰ汾;1~8λʾβ;
//			:ֵ0x00030107ʾ:汾3,ΰ汾1,7.
//------------------------------------------------------------------------
PLAYSDK_API DWORD CALLMETHOD PLAY_GetSdkVersion();

//------------------------------------------------------------------------
// : PLAY_GetLastError
// : ȡ
// : nPort,ͨ
// : DWORD,õǰĴ.μ궨.
//------------------------------------------------------------------------
PLAYSDK_API DWORD CALLMETHOD PLAY_GetLastError(LONG nPort);

//------------------------------------------------------------------------
// : PLAY_RefreshPlay
// : ˢʾ.ûͣʱˢ˴,򴰿еͼΪˢ¶ʧ,
//			ʱӿڿ°ͼʾ.ֻͣ͵֡ʱ
//			ִ,ֱӷ.
// : nPort,ͨ
// : BOOL,ɹTRUE,ʧܷFALSE.
//------------------------------------------------------------------------
PLAYSDK_API BOOL CALLMETHOD PLAY_RefreshPlay(LONG nPort);

//------------------------------------------------------------------------
// : PLAY_GetPictureSize
// : ȡԭʼͼС,ݴ˴Сʾڵ,ԲԿ
//			,Щ֧ӲŵԿ˵ǳ.
// : nPort,ͨ
//		 pWidth,,ͼƬ
//		 pHeight,,ͼƬ߶
// : BOOL,ɹTRUE,ʧܷFALSE.
//------------------------------------------------------------------------
PLAYSDK_API BOOL CALLMETHOD PLAY_GetPictureSize(LONG nPort,LONG *pWidth,LONG *pHeight);

//------------------------------------------------------------------------
// : PLAY_SetPicQuality
// : ͼ,óɸʱЧ,CPUʸ.ֶ֧·ʱ
//			Ϊ,ԽCPU.ĳ·Ŵ󲥷ʱ·óɸ
//			ԴﵽõĻЧ.
// : nPort,ͨ
//		 bHighQuality,ΪTRUE(1)ʱͼ,ΪFALSE(0)ʱ(Ĭֵ).
// : BOOL,ɹTRUE,ʧܷFALSE.
//------------------------------------------------------------------------
PLAYSDK_API BOOL CALLMETHOD PLAY_SetPicQuality(LONG nPort,BOOL bHighQuality);

//------------------------------------------------------------------------
// : PLAY_PlaySoundShare
// : Թʽ,ű·ȥر·.
// : nPort,ͨ
// : BOOL,ɹTRUE,ʧܷFALSE.
//------------------------------------------------------------------------
PLAYSDK_API BOOL CALLMETHOD PLAY_PlaySoundShare(LONG nPort);

//------------------------------------------------------------------------
// : PLAY_StopSoundShare
// : ر(ʽ).ͬһ,ͨʹͬķʽŻر.
// : nPort,ͨ
// : BOOL,ɹTRUE,ʧܷFALSE.
//------------------------------------------------------------------------
PLAYSDK_API BOOL CALLMETHOD PLAY_StopSoundShare(LONG nPort);

//------------------------------------------------------------------------
// : PLAY_GetStreamOpenMode
// : ȡģʽ
// : nPort,ͨ
// : LONG,STREAME_REALTIMESTREAME_FILE.
//------------------------------------------------------------------------
PLAYSDK_API LONG CALLMETHOD PLAY_GetStreamOpenMode(LONG nPort);

//------------------------------------------------------------------------
// : PLAY_GetVolume
// : ȡ,ָ.
// : nPort,ͨ
// : WORD,ֵ
//------------------------------------------------------------------------
PLAYSDK_API WORD CALLMETHOD PLAY_GetVolume(LONG nPort);

//------------------------------------------------------------------------
// : PLAY_GetPictureQuality
// : ȡͼ
// : nPort,ͨ
//		 bHighQuality,,TRUEʾ,FALSEʾ.
// : BOOL,ɹTRUE,ʧܷFALSE.
//------------------------------------------------------------------------
PLAYSDK_API BOOL CALLMETHOD PLAY_GetPictureQuality(LONG nPort,BOOL *bHighQuality);

//------------------------------------------------------------------------
// : PLAY_GetSourceBufferRemain
// : ȡģʽԴʣݴС
// : nPort,ͨ
// : DWORD,ǰԴĴСλBYTE(ֽ).
//------------------------------------------------------------------------
PLAYSDK_API DWORD CALLMETHOD PLAY_GetSourceBufferRemain(LONG nPort);

//------------------------------------------------------------------------
// : PLAY_ResetSourceBuffer
// : ģʽԴʣ
// : nPort,ͨ
// : BOOL,ɹTRUE,ʧܷFALSE.
//------------------------------------------------------------------------
PLAYSDK_API BOOL CALLMETHOD PLAY_ResetSourceBuffer(LONG nPort);

//------------------------------------------------------------------------
// : PLAY_OneByOneBack
// : ֡,˽ӿֻ֧ļ,ļ֮ܵ.ÿ
//			һεһ֡
// : nPort,ͨ
// : BOOL,ɹTRUE,ʧܷFALSE.
//------------------------------------------------------------------------
PLAYSDK_API BOOL CALLMETHOD PLAY_OneByOneBack(LONG nPort);

//------------------------------------------------------------------------
// : PLAY_SetCurrentFrameNum
// : ļǰ֡֡,˺ļ֮ܵ.
// : nPort,ͨ
//		 nFrameNum,֡
// : BOOL,ɹTRUE,ʧܷFALSE.
//------------------------------------------------------------------------
PLAYSDK_API BOOL CALLMETHOD PLAY_SetCurrentFrameNum(LONG nPort,DWORD nFrameNum);

//------------------------------------------------------------------------
// : PLAY_GetKeyFramePos
// : ָλ֮ǰĹؼ֡λ,ͼӹؼ֡ʼû
//			ļǴӹؼ֡ʼ,ôһؼ֮֡ǰݻᱻ.
//			ûҪȡļеһ,ӦÿǴӹؼ֡ʼȡ.λ
//			ϵ,ඪʧ3֡.ļȫǰ,
//			PLAY_GetNextKeyFramePosʹ,ʵּ¼ļ,
//			ؼ֡й.
// : nPort,ͨ
//		 nValue,ǰλ,ʱ֡,nTypeָ.
//		 nType,ָnValue.nTypeBY_FRAMENUM,nValueʾ֡;
//			nTypeBY_FRAMTIME,nValueʾʱ,λms.
//		 pFramePos,ҵĹؼ֡ļλϢṹָ,PFRAME_POS.
// : BOOL,ɹTRUE,ʧܷFALSE.
//------------------------------------------------------------------------
PLAYSDK_API BOOL CALLMETHOD PLAY_GetKeyFramePos(LONG nPort,DWORD nValue, DWORD nType, PFRAME_POS pFramePos);

//------------------------------------------------------------------------
// : PLAY_GetNextKeyFramePos
// : ָλ֮Ĺؼ֡λ
// : nPort,ͨ
//		 nValue,ǰλ,ʱ֡,nTypeָ.
//		 nType,ָnValue.nTypeBY_FRAMENUM,nValueʾ֡;
//			nTypeBY_FRAMTIME,nValueʾʱ,λms.
//		 pFramePos,ҵĹؼ֡ļλϢṹָ,PFRAME_POS.
// : BOOL,ɹTRUE,ʧܷFALSE.
//------------------------------------------------------------------------
PLAYSDK_API BOOL CALLMETHOD PLAY_GetNextKeyFramePos(LONG nPort,DWORD nValue, DWORD nType, PFRAME_POS pFramePos);

//------------------------------------------------------------------------
// : PLAY_SetDecCBStream
// : ýص,PLAY_Play֮ǰ.
// : nPort,ͨ
//		 nStream,1 Ƶ;2 Ƶ;3 .
// : BOOL,ɹTRUE,ʧܷFALSE.
//------------------------------------------------------------------------
PLAYSDK_API BOOL CALLMETHOD PLAY_SetDecCBStream(LONG nPort,DWORD nStream);

//------------------------------------------------------------------------
// : PLAY_SetDisplayRegion
// : ûʾ,ֲŴʾ.
// : nPort,ͨ
//		 nRegionNum,ʾ,0~(MAX_DISPLAY_WND-1),Ϊ0,õʾ.
//		 pSrcRect,ֲʾ
//		 hDestWnd,ʾھ
//		 bEnable,()رʾ
// : BOOL,ɹTRUE,ʧܷFALSE.
//------------------------------------------------------------------------
PLAYSDK_API BOOL CALLMETHOD PLAY_SetDisplayRegion(LONG nPort,DWORD nRegionNum, DISPLAYRECT *pSrcRect, HWND hDestWnd, BOOL bEnable);


//------------------------------------------------------------------------
// : PLAY_GetRefValue
// : ȡļ,Ա´δͬһļʱֱʹϢ.ɺܻϢ.
// : nPort,ͨ
//		 pBuffer,Ϣ
//		 pSize,pBufferĴС,ϢС.ڵһָpSize=0,pBuffer=NULL,
//			pSizeķֵҪĻС.Ȼ㹻Ļ,ٵһ.	 
// : BOOL,ɹTRUE,ʧܷFALSE.
//------------------------------------------------------------------------
PLAYSDK_API BOOL CALLMETHOD PLAY_GetRefValue(LONG nPort,BYTE *pBuffer, DWORD *pSize);

//------------------------------------------------------------------------
// : PLAY_SetRefValue
// : ļ,Ϣ䳤ȱ׼ȷ.ѾļϢ,
//			ٵĻصPLAY_SetFileRefCallBackEx,ֱϢ.
// : nPort,ͨ
//		 pBuffer,Ϣ
//		 nSize,Ϣĳ
// : BOOL,ɹTRUE,ʧܷFALSE.
//------------------------------------------------------------------------
PLAYSDK_API BOOL CALLMETHOD PLAY_SetRefValue(LONG nPort,BYTE *pBuffer, DWORD nSize);

//------------------------------------------------------------------------
// : PLAY_RigisterDrawFun
// : עһص,õǰdevice context,DCϻͼ(),
//			ͺڴڵĿͻDCϻͼ,DCǴڿͻDC,DirectDraw
//			Off-ScreenDC.ע,ʹoverlay,ӿЧ,ֱ
//			ϻͼ,ֻҪ͸ɫͲᱻ.
// : nPort,ͨ
//		 DrawFun,ͼص,:
//			nPort,ͨ
//			hDc,OffScreen豸.
//			pUserData,û,û
// : BOOL,ɹTRUE,ʧܷFALSE.
//------------------------------------------------------------------------
typedef void (CALLBACK* fDrawCBFun)(LONG nPort,HDC hDc, void* pUserData);
PLAYSDK_API BOOL CALLMETHOD PLAY_RigisterDrawFun(LONG nPort, fDrawCBFun DrawCBFun, void* pUserData);

//------------------------------------------------------------------------
// : PLAY_ResetBuffer
// : ָʣ
// : nPort,ͨ
//		 nBufType,:
//			BUF_VIDEO_SRC 1 ƵԴ
//			BUF_AUDIO_SRC 2 ƵԴ
//			BUF_VIDEO_RENDER 3 Ƶݻ
//			BUF_AUDIO_RENDER 4 Ƶݻ
// : BOOL,ɹTRUE,ʧܷFALSE.
//------------------------------------------------------------------------
PLAYSDK_API BOOL CALLMETHOD PLAY_ResetBuffer(LONG nPort,DWORD nBufType);

//------------------------------------------------------------------------
// : PLAY_GetBufferValue
// : ȡָĴС
// : nPort,ͨ
//		 nBufType,:
//			BUF_VIDEO_SRC 1 ƵԴ
//			BUF_AUDIO_SRC 2 ƵԴ
//			BUF_VIDEO_RENDER 3 Ƶݻ
//			BUF_AUDIO_RENDER 4 Ƶݻ
// : DWORD,ݲͬػֵ,Դbyte,󻺳֡.
//------------------------------------------------------------------------
PLAYSDK_API DWORD CALLMETHOD PLAY_GetBufferValue(LONG nPort,DWORD nBufType);

//------------------------------------------------------------------------
// : PLAY_AdjustWaveAudio
// : WAVE,ԸıĴС.PLAY_SetVolumeĲͬ,ǵ
//			,ֻԸ·,PLAY_SetVolumeǵ,ϵͳ.
// : nPort,ͨ
//		 nCoefficient,Ĳ,ΧMIN_WAVE_COEFMAX_WAVE_COEF,0ǲ
// : BOOL,ɹTRUE,ʧܷFALSE.
//------------------------------------------------------------------------
PLAYSDK_API BOOL CALLMETHOD PLAY_AdjustWaveAudio(LONG nPort,LONG nCoefficient);

//------------------------------------------------------------------------
// : PLAY_SetAudioCallBack
// : ƵWAVEݻص.
// : nPort,ͨ
//		 funAudio,Ƶص,
//			nPort,ͨ
//			pAudioBuf,waveʽƵ
//			nSize,Ƶݳ
//			nStamp,ʱ(ms)
//			nType,ƵT_AUDIO16, 8000ÿ16λʾ
//			pUserData,ûԶ
// : BOOL,ɹTRUE,ʧܷFALSE.
//------------------------------------------------------------------------
typedef void (CALLBACK * fAudioCBFun)(LONG nPort, char * pAudioBuf, LONG nSize, LONG nStamp, LONG nType, void* pUserData);
PLAYSDK_API BOOL CALLMETHOD PLAY_SetAudioCallBack(LONG nPort, fAudioCBFun AudioCBFun, void* pUserData);

//------------------------------------------------------------------------
// : PLAY_SetEncTypeChangeCallBack
// : ͼֱʸı֪ͨص,ļǰʹ.
// : nPort,ͨ
//		 funEncChange,ص
//			nPort,ͨ
//			pUserData,ûԶ
//		 pUserData,ûԶ
// : BOOL,ɹTRUE,ʧܷFALSE.
//------------------------------------------------------------------------
typedef void(CALLBACK *fEncChangeCBFun)(LONG nPort, void* pUserData);
PLAYSDK_API BOOL CALLMETHOD PLAY_SetEncTypeChangeCallBack(LONG nPort, fEncChangeCBFun EncChangeCBFun, void* pUserData);

//------------------------------------------------------------------------
// : PLAY_SetEncTypeChangeCallBackEx
// : ͼֱʸı֪ͨص,ļǰʹ.
// : nPort,ͨ
//		 funEncChange,ص
//			nPort,ͨ
//			pUserData,ûԶ
//		 pUserData,ûԶ
// : BOOL,ɹTRUE,ʧܷFALSE.
//------------------------------------------------------------------------
typedef void(CALLBACK *fEncChangeCBFunEx)(LONG nPort, void* pUserData,LONG nWidth, LONG nHeight);
PLAYSDK_API BOOL CALLMETHOD PLAY_SetEncTypeChangeCallBackEx(LONG nPort, fEncChangeCBFunEx EncChangeCBFun, void* pUserData);

//------------------------------------------------------------------------
// : PLAY_SetColor
// : Ƶ
// : nPort,ͨ
//		 nRegionNum,ʾ,οPLAY_SetDisplayRegion;ֻһʾ(ͨ)Ϊ0.
//		 nBrightness,,Ĭ64;Χ0-128.
//		 nContrast,Աȶ,Ĭ64;Χ0-128.
//		 nSaturation,Ͷ,Ĭ64;Χ0-128.
//		 nHue,ɫ,Ĭ64;Χ0-128.
// : BOOL,ɹTRUE,ʧܷFALSE.
//------------------------------------------------------------------------
PLAYSDK_API BOOL CALLMETHOD PLAY_SetColor(LONG nPort, DWORD nRegionNum, int nBrightness, int nContrast, int nSaturation, int nHue);

//------------------------------------------------------------------------
// : PLAY_GetColor
// : ȡƵ
// : nPort,ͨ
//		 nRegionNum,ʾ,οPLAY_SetDisplayRegion;ֻһʾ(ͨ)Ϊ0.
//		 pBrightness,,Ĭ64;Χ0-128.
//		 pContrast,Աȶ,Ĭ64;Χ0-128.
//		 pSaturation,Ͷ,Ĭ64;Χ0-128.
//		 pHue,ɫ,Ĭ64;Χ0-128.
// : BOOL,ɹTRUE,ʧܷFALSE.
//------------------------------------------------------------------------
PLAYSDK_API BOOL CALLMETHOD PLAY_GetColor(LONG nPort, DWORD nRegionNum, int *pBrightness, int *pContrast, int *pSaturation, int *pHue);

//------------------------------------------------------------------------
// : PLAY_SetEncChangeMsg
// : ÷ֱʸı֪ͨϢ
// : nPort,ͨ
//		 hWnd,Ϣ͵Ĵ
//		 nMsg,ûϢ,ʱʽıʱûhWndڹյϢ.
// : BOOL,ɹTRUE,ʧܷFALSE.
//------------------------------------------------------------------------
PLAYSDK_API BOOL CALLMETHOD PLAY_SetEncChangeMsg(LONG nPort,HWND hWnd,UINT nMsg);

//------------------------------------------------------------------------
// : PLAY_CatchPic
// : ץͼ,BMPͼƬΪָļ.PLAY_SetDisplayCallBackõƵ
//			ݻص,ֻƵݽʱŵ,ûƵ
//			(ץͼ),н,Ͳϵص.PLAY_
//			CatchPicһֻץһͼ,ͣ͵֡ʱʵץͼ.:
//			ûʵץͼ(һץһͼ),PLAY_CatchPic,õһ
//			ʱڵƵ,PLAY_SetDisplayCallBack.
// : nPort,ͨ
//		 sFileName,ļ
// : BOOL,ɹTRUE,ʧܷFALSE.
//------------------------------------------------------------------------
PLAYSDK_API BOOL CALLMETHOD PLAY_CatchPic(LONG nPort,char* sFileName) ;

//------------------------------------------------------------------------
// : PLAY_CatchPicEx
// : PLAY_CatchPicչӿ,÷PLAY_CatchPic.ָͼƬʽ
// : nPort,ͨ
//		 sFileName,ļ
//		 ePicfomat,ͼƬʽ,tPicFormats.
// : BOOL,ɹTRUE,ʧܷFALSE.
//------------------------------------------------------------------------
PLAYSDK_API BOOL CALLMETHOD PLAY_CatchPicEx(LONG nPort,char* sFileName,tPicFormats ePicfomat);

//------------------------------------------------------------------------
// : PLAY_SetFileEndCallBack
// : ļص
// : nPort,ͨ
//		 pFileEnd,صָ,:
//			nPort,ͨ
//			pUserData,ûԶ
//		 pUserData,ûԶ
// : BOOL,ɹTRUE,ʧܷFALSE.
//------------------------------------------------------------------------
typedef void (CALLBACK *fpFileEndCBFun)(DWORD nPort, void* pUserData);
PLAYSDK_API BOOL CALLMETHOD PLAY_SetFileEndCallBack(LONG nPort, fpFileEndCBFun pFileEndCBFun, void* pUserData);

//------------------------------------------------------------------------
// : PLAY_StartDataRecord
// : ʼ¼,ֻģʽ,PLAY_Play֮.
// : nPort,ͨ
//		 sFileName,¼ļ,ļвڵļ,ʹļ.
//		 idataType,0ʾԭʼƵ;1ʾתAVIʽ;2ʾתASFʽ;3ֶαļ
// : BOOL,ɹTRUE,ʧܷFALSE.
//------------------------------------------------------------------------
PLAYSDK_API BOOL CALLMETHOD PLAY_StartDataRecord(LONG nPort, char *sFileName, int idataType);

//------------------------------------------------------------------------
// : PLAY_WriteData
// : ԭʼ
// : nPort,ͨ
//		 pBuf,
//		 nSize,С
// : BOOL,ɹTRUE,ʧܷFALSE.
//------------------------------------------------------------------------
PLAYSDK_API BOOL CALLMETHOD PLAY_WriteData(LONG nPort, PBYTE pBuf,DWORD nSize);

//------------------------------------------------------------------------
// : PLAY_StopDataRecord
// : ֹͣ¼
// : nPort,ͨ
// : BOOL,ɹTRUE,ʧܷFALSE.
//------------------------------------------------------------------------
PLAYSDK_API BOOL CALLMETHOD PLAY_StopDataRecord(LONG nPort);

//------------------------------------------------------------------------
// : PLAY_SetPlaySpeed
// : ıͼ񲥷ŵٶ,
// : nPort,ͨ
//		 fCoff,ٶ,Χ[1/64~64.0],С1ʾţ1ʾ.
//			   ٶȽϿʱܻ֡.
// : BOOL,ɹTRUE,ʧܷFALSE.
//------------------------------------------------------------------------
PLAYSDK_API BOOL CALLMETHOD PLAY_SetPlaySpeed(LONG nPort, float fCoff);

//------------------------------------------------------------------------
// : PLAY_QueryInfo
// : Ŀǰʵ˶Եǰʱ֡ϢĲѯ.
// : nPort,ͨ
//		 cmdType,ָ״̬ѯָ,
//			PLAY_CMD_GetTime   ȡʱϢ,λms.
//			PLAY_CMD_GetFileRate  ȡ֡Ϣ
//			PLAY_CMD_GetMediaInfo  ȡýϢ,ϢṹΪ MEDIA_INFO
//			PLAY_CMD_GetRenderTime  ϢṹΪtm<time.h>ж
//		 buf,ϢĻ
//		 buflen,峤
//		 returnlen,ȡϢЧݳ
// : BOOL,ɹTRUE,ʧܷFALSE.
//------------------------------------------------------------------------
PLAYSDK_API BOOL CALLMETHOD PLAY_QueryInfo(LONG nPort , int cmdType, char* buf, int buflen, int* returnlen);

//------------------------------------------------------------------------
// : PLAY_OpenAudioRecord
// : Ƶɼ.
// : pProc,Ƶɼݻصָ,:
//			pDataBuffer,صָ
//			DataLength,صݳ
//			pUserData,û
//		 nBitsPerSample,ʾÿҪλ
//		 nSamplesPerSec,
//		 nLength,ݻĳ
//		 nReserved,
//		 pUserData,ûԶ
// : BOOL,ɹTRUE,ʧܷFALSE.
//------------------------------------------------------------------------
typedef void (CALLBACK *pCallFunction)(LPBYTE pDataBuffer, DWORD DataLength, void* pUserData);
PLAYSDK_API BOOL CALLMETHOD PLAY_OpenAudioRecord(pCallFunction pProc, LONG nBitsPerSample, LONG nSamplesPerSec, LONG nLength, LONG nReserved, void* pUserData);

//------------------------------------------------------------------------
// : PLAY_CloseAudioRecord
// : رƵɼ
// : 
// : BOOL,ɹTRUE,ʧܷFALSE.
//------------------------------------------------------------------------
PLAYSDK_API BOOL CALLMETHOD PLAY_CloseAudioRecord();

//------------------------------------------------------------------------
// : PLAY_SetWaterMarkCallBack
// : ˮӡݻصע⣺ˮӡУصú󽫲нʾ
// : nPort,ͨ
//		 pFunc,ˮӡϢȡص,:
//			buf,ˮӡbufferָ
//			key,ֲͬˮӡϢ
//			len,󳤶
//			reallen,ʵʳ
//			type,ֵΧ[0,3],
//				0  I֡֡ˮӡϢ
//				1  ֡ˮӡ
//				2  ˮӡУ 
//				3  ܷ֡
//		 pUserData,ûԶ 
// : BOOL,ɹTRUE,ʧܷFALSE.
//------------------------------------------------------------------------
typedef int (CALLBACK* GetWaterMarkInfoCallbackFunc)(char* buf, LONG key, LONG len, LONG reallen, LONG type, void* pUserData);	
PLAYSDK_API BOOL CALLMETHOD PLAY_SetWaterMarkCallBack(LONG nPort, GetWaterMarkInfoCallbackFunc pFunc, void* pUserData);

//------------------------------------------------------------------------
// : PLAY_CreateFile
// : ļԶͨ
// : sFileName,ļ
// : DWORD,ʧܷ0,򷵻ͨ.
//------------------------------------------------------------------------
PLAYSDK_API DWORD CALLMETHOD PLAY_CreateFile(LPSTR sFileName);

//------------------------------------------------------------------------
// : PLAY_DestroyFile
// : رղļͷԶͨ.
// : nPort,ͨ
// : BOOL,ɹTRUE,ʧܷFALSE.
//------------------------------------------------------------------------
PLAYSDK_API BOOL CALLMETHOD PLAY_DestroyFile(LONG nPort);

//------------------------------------------------------------------------
// : PLAY_CreateStream
// : ӿڲԶͨ
// : nBufPoolSize,òдĻС,Χ[SOURCE_BUF_MIN,SOURCE_BUF_MAX].
// : DWORD,ʧܷ0,򷵻ͨ.
//------------------------------------------------------------------------
PLAYSDK_API DWORD CALLMETHOD PLAY_CreateStream(DWORD nBufPoolSize);

//------------------------------------------------------------------------
// : PLAY_DestroyStream
// : ر,ͷԶͨ.
// : nPort,ͨ
// : BOOL,ɹTRUE,ʧܷFALSE.
//------------------------------------------------------------------------
PLAYSDK_API BOOL CALLMETHOD PLAY_DestroyStream(LONG nPort);

//------------------------------------------------------------------------
// : PLAY_GetFreePort
// : ȡͨ,Ϊ501.PLAY_ReleasePortƥʹ.
// : plPort,,ػȡͨ.
// : BOOL,ɹTRUE,ʧܷFALSE.
//------------------------------------------------------------------------
PLAYSDK_API BOOL CALLMETHOD PLAY_GetFreePort(LONG *plPort);

//------------------------------------------------------------------------
// : PLAY_ReleasePort
// : ͷͨ,PLAY_RealsePortƥʹ.
// : nPort,ͨ
// : BOOL,ɹTRUE,ʧܷFALSE.
//------------------------------------------------------------------------
PLAYSDK_API BOOL CALLMETHOD PLAY_ReleasePort(LONG lPort);

//------------------------------------------------------------------------
// : PLAY_VerticalSyncEnable
// : ֱͬʾ.˽ӿPLAY_Play֮,²ʱ.
//			ڲŶ̬ͼֶϲʱ,ʹô˽ӿڴ򿪴ֱͬ.
// : nPort,ͨ
//		 bEnable,TRUE򿪴ֱͬ;FALSEرմֱͬ.
// : BOOL,ɹTRUE,ʧܷFALSE.
//------------------------------------------------------------------------
PLAYSDK_API	BOOL CALLMETHOD PLAY_VerticalSyncEnable(LONG nPort, BOOL bEnable);

//------------------------------------------------------------------------
// : PLAY_GetPicBMP
// : ץȡBMPͼ
// : nPort,ͨ
//		 pBmpBuf,BMPͼݵĻַ,û,Сbmp ͼС,
//			ƼС:sizeof(BITMAPFILEHEADER)+sizeof(BITMAPINFOHEADER)+w*h*4,
//			whֱΪͼ.
//		 dwBufSize,С
//		 pBmpSize,ȡʵbmp ͼС
// : BOOL,ɹTRUE,ʧܷFALSE.
//------------------------------------------------------------------------
PLAYSDK_API BOOL CALLMETHOD PLAY_GetPicBMP(LONG nPort, PBYTE pBmpBuf, DWORD dwBufSize, DWORD* pBmpSize);

//------------------------------------------------------------------------
// : PLAY_GetPicBMPEx
// : ץȡBMPͼ
// : nPort,ͨ
//		 pBmpBuf,BMPͼݵĻַ,û,Сbmp ͼС,
//			ƼС:sizeof(BITMAPFILEHEADER)+sizeof(BITMAPINFOHEADER)+w*h*4,
//			whֱΪͼ.
//		 dwBufSize,С
//		 pBmpSize,ȡʵbmp ͼС
//		 nWidth,ָbmpĿ
//		 nHeight,ָbmpĸ
//		 nRgbType,ָRGBʽ 0RGB32;1RGB24;
// : BOOL,ɹTRUE,ʧܷFALSE.
PLAYSDK_API BOOL CALLMETHOD PLAY_GetPicBMPEx(LONG nPort, PBYTE pBmpBuf, DWORD dwBufSize, DWORD* pBmpSize, LONG nWidth, LONG nHeight, int nRgbType);

//------------------------------------------------------------------------
// : PLAY_GetPicJPEG
// : ץȡJPEGͼ.
// : nPort,ͨ
//		 pJpegBuf,JPEGͼݵĻַ,û,СJPEGͼС,
//			ƼС:w*h*3/2,whֱΪͼ.
//		 dwBufSize,С.
//		 pJpegSize,ȡʵJPEGͼС.
//		 quality,JPEGͼѹ,ȡֵΧΪ(0,100].
// : BOOL,ɹTRUE,ʧܷFALSE.
//------------------------------------------------------------------------
PLAYSDK_API BOOL CALLMETHOD PLAY_GetPicJPEG(LONG nPort, PBYTE pJpegBuf, DWORD dwBufSize, DWORD* pJpegSize, int quality);

//------------------------------------------------------------------------
// : PLAY_GetPicTIFF
// : ץȡTIFFͼ
// : nPort,ͨ
//		 pTiffBuf,TIFFͼݵĻַ,û,СtiffͼС,
//			ƼС:w*h*3+1024,
//			whֱΪͼ.
//		 dwBufSize,С
//		 pTiffSize,ȡʵTIFFͼС
// : BOOL,ɹTRUE,ʧܷFALSE.
//------------------------------------------------------------------------
PLAYSDK_API BOOL CALLMETHOD PLAY_GetPicTIFF(LONG nPort, PBYTE pTiffBuf, DWORD dwBufSize, DWORD* pTiffSize);

//------------------------------------------------------------------------
// : PLAY_SetVisibleDecodeCallBack
// : ص.PLAY_SetDecodeCallBackͬ,ͬǽصͬʱ
//			ʾƵ,鲻Ҫڻصʱ߼,ʾʱ.
// : nPort,ͨ
//		 cbDec,صָ,ΪNULL.ص:
//			nPort,ͨ
//			pFrameDecodeInfo,Ƶ
//			pFrameInfo,ͼϢ,μFRAME_INFOṹ
//			pUser,ûԶ
//		 pUser,ûԶ
// : BOOL,ɹTRUE,ʧܷFALSE.
PLAYSDK_API BOOL CALLMETHOD PLAY_SetVisibleDecodeCallBack(LONG nPort, fCBDecode cbDec, void* pUser);

//------------------------------------------------------------------------
// : PLAY_RigisterDrawFunEx
// : עһص,õǰ(HDC),DCǴڿͻDC,
//			DirectDrawOff-ScreenDC.ע.ʹoverlay,
//			ӿЧ,overlayʽֱڴϻͼ,ֻҪ͸ɫͲᱻ.
// : nPort,ͨ
//		 nReginNum,ʾ,Χ[0,(MAX_DISPLAY_WND-1)].nRegionNumΪ0,
//			õʾ.
//		 DrawFunEx,ͼص,:
//			nPort,ͨ
//			hDc,Off-Screen豸(DC)
//			pUserData,ûԶ
//		 pUserData,ûԶ
// : BOOL,ɹTRUE,ʧܷFALSE.
//------------------------------------------------------------------------
typedef void (CALLBACK* fDrawCBFunEx)(LONG nPort,LONG nReginNum,HDC hDc, void* pUserData);
PLAYSDK_API BOOL CALLMETHOD PLAY_RigisterDrawFunEx(LONG nPort, LONG nReginNum, fDrawCBFunEx DrawFunEx, void* pUserData);

//------------------------------------------------------------------------
// : PLAY_CatchResizePic
// : ץͼ,ѡʽָ.
// : nPort,ͨ
//		 sFileName,ļ
//		 lTargetWidth,ָͼ
//		 lTargetHeight,ָͼ߶
//		 ePicfomat,ͼƬʽ,tPicFomats
// : BOOL,ɹTRUE,ʧܷFALSE.
//------------------------------------------------------------------------
PLAYSDK_API BOOL CALLMETHOD PLAY_CatchResizePic(LONG nPort, char* sFileName, LONG lTargetWidth, LONG lTargetHeight, tPicFormats ePicfomat);

//------------------------------------------------------------------------
// : PLAY_GetRealFrameBitRate
// : ȡƵʵʱ
// : nPort,ͨ
//		 pBitRate,,Ƶ.
// : BOOL,ɹTRUE,ʧܷFALSE.
//------------------------------------------------------------------------
PLAYSDK_API BOOL CALLMETHOD PLAY_GetRealFrameBitRate(LONG nPort, double* pBitRate);


//------------------------------------------------------------------------
// : PLAY_SetFileRefCallBackEx
// : ýص,Է.
// : nPort,ͨ
//		 pFileRefDoneEx,صָ,:
//			nPort,ͨ
//			bIndexCreated,־,TRUEɹ;FALSEʧ.
//			pUserData,ûԶ
//		 pUserData,ûԶ
// : BOOL,ɹTRUE,ʧܷFALSE.
//------------------------------------------------------------------------
typedef void (CALLBACK *fpFileRefDoneCBFunEx)(DWORD nPort, BOOL bIndexCreated, void* pUserData);
PLAYSDK_API BOOL CALLMETHOD PLAY_SetFileRefCallBackEx(LONG nPort, fpFileRefDoneCBFunEx pFileRefDoneCBFunEx, void* pUserData);

//------------------------------------------------------------------------
// : PLAY_StartAVIConvert
// : ʼAVIתAVIת״̬ص.
// : nPort,ͨ
//		 pAVIFunc,ص,:
//			nPort,ͨ
//			lMediaChangeType,AVI_MEDIACHANGE_FRAMERATEʾ֡ʸı;AVI_MEDIACHANGE_RESOLUTIONʾֱʸı
//			lUser,ûԶ
//			pIsNewFile,TRUE ֶת;FALSE ֶΣĬϲֶ
//			sNewFileName,ֶת,µ¼ļ
//		 lUser,ûԶ
// : BOOL,ɹTRUE,ʧܷFALSE.
//------------------------------------------------------------------------
typedef void (CALLBACK* AVIConvertCallback)(LONG nPort, LONG lMediaChangeType, void* pUserData, BOOL *pIsNewFile, char *sNewFileName);
PLAYSDK_API BOOL CALLMETHOD PLAY_StartAVIConvert(LONG nPort, char *sFileName, AVIConvertCallback pAVIFunc, void* pUserData);

//------------------------------------------------------------------------
// : PLAY_StopAVIConvert
// : ֹͣAVIת.
// : nPort,ͨ
// : BOOL,ɹTRUE,ʧܷFALSE.
//------------------------------------------------------------------------
PLAYSDK_API BOOL CALLMETHOD PLAY_StopAVIConvert(LONG nPort);

//------------------------------------------------------------------------
// : PLAY_SetWaterMarkCallBackEx
// : ˮӡݻصע⣺ˮӡУصú󽫲нʾ
// : nPort,ͨ
//		 pFunc,ָ,:
//			nPort,ͨ
//			buf,ˮӡݻ
//			lTimeStamp,ˮӡʱ
//			lInfoType,ˮӡϢ,,WATERMARK_DATA_TEXT,
//				WATERMARK_DATA_JPEG_BMP,WATERMARK_DATA_FRAMEDATA
//		 len,󳤶
//		 reallen,ʵʳ
//		 lCheckResult,1ûд;2ˮӡ;3֡ݴ;4֡Ŵ
//		 pUserData,ûԶ
// : BOOL,ɹTRUE,ʧܷFALSE.
//------------------------------------------------------------------------
typedef int (CALLBACK* GetWaterMarkInfoCallbackFuncEx)(LONG nPort, char* buf, LONG lTimeStamp, LONG lInfoType, LONG len, LONG reallen, LONG lCheckResult, void* pUserData);
PLAYSDK_API BOOL CALLMETHOD PLAY_SetWaterMarkCallBackEx(LONG nPort, GetWaterMarkInfoCallbackFuncEx pFunc, void* pUserData);

//------------------------------------------------------------------------
// : PLAY_SetAudioRecScaling
// : Ƶɼű
// : fRatio,ű.0С1ΪƵС;1ΪԭʼƵ;1ΪƵŴ.
// : BOOL,ɹTRUE,ʧܷFALSE.
//------------------------------------------------------------------------
PLAYSDK_API BOOL CALLMETHOD PLAY_SetAudioRecScaling(float fRatio);

//------------------------------------------------------------------------
// : PLAY_GetAudioRecScaling
// : ȡƵɼű
// : pfRatio,ű.0С1ΪƵС;1ΪԭʼƵ;1ΪƵŴ.
// : BOOL,ɹTRUE,ʧܷFALSE.
//------------------------------------------------------------------------
PLAYSDK_API BOOL CALLMETHOD PLAY_GetAudioRecScaling(float* pfRatio);

//------------------------------------------------------------------------
// : PLAY_SetAudioRenderScaling
// : Ƶű
// : nPort,ͨ
//		 fRatio,ű.0С1ΪƵС;1ΪԭʼƵ;1ΪƵŴ.
// : BOOL,ɹTRUE,ʧܷFALSE.
//------------------------------------------------------------------------
PLAYSDK_API BOOL CALLMETHOD PLAY_SetAudioRenderScaling(LONG nPort, float fRatio);

//------------------------------------------------------------------------
// : PLAY_GetAudioRenderScaling
// : ȡƵű
// : nPort,ͨ
//		 pfRatio,ű.0С1ΪƵС;1ΪԭʼƵ;1ΪƵŴ.
// : BOOL,ɹTRUE,ʧܷFALSE.
//------------------------------------------------------------------------
PLAYSDK_API BOOL CALLMETHOD PLAY_GetAudioRenderScaling(LONG nPort, float* pfRatio);

//------------------------------------------------------------------------
// : PLAY_SetRotateAngle
// : ͼת
// : nrotateType,ת,Χ[0,3]. 0ת;1ת90;2ת180;3ת270.
// : BOOL,ɹTRUE,ʧܷFALSE.
//------------------------------------------------------------------------
PLAYSDK_API BOOL CALLMETHOD PLAY_SetRotateAngle(LONG nPort , int nrotateType);

//------------------------------------------------------------------------
// : PLAY_SetDelayTime
// : ӳʱ
// : nDelay(ms),ӳʱ䣬ʱ俪ʼţСڴֵʼ΢
//       nThreshold(ms),ֵʱ䣬﷧ֵʼ΢
// : BOOL,ɹTRUE,ʧܷFALSE.
//------------------------------------------------------------------------
PLAYSDK_API BOOL CALLMETHOD PLAY_SetDelayTime(LONG nPort, int nDelay, int nThreshold);

//------------------------------------------------------------------------
// : PLAY_SetPlayMethod
// : òŲԲֻʵʱЧ
// : nStartTime,ʼŵʱ(ms)
//       nSlowTime,ʼŵʱ(ms)
//		 nFastTime,ʼŵʱ(ms)
//		 nFailedTime,ʱͶʧ(ms)
// : BOOL,ɹTRUE,ʧܷFALSE.
//------------------------------------------------------------------------
PLAYSDK_API BOOL CALLMETHOD PLAY_SetPlayMethod(LONG nPort, int nStartTime, int nSlowTime, int nFastTime, int nFailedTime);

//------------------------------------------------------------------------
// : PLAY_BackOne
// : PLAY_OneByOneBackظʹPLAY_OneByOneBack
// : 
// : 
//------------------------------------------------------------------------
PLAYSDK_API BOOL CALLMETHOD PLAY_BackOne(LONG nPort);

//------------------------------------------------------------------------
// : PLAY_SetDecCallBack(ʹPLAY_SetDecodeCallBack)
// : ýص,滻еʾ,ûԼʾ,ú
//			PLAY_Play֮ǰ,PLAY_StopʱԶʧЧ,´εPLAY_Play֮ǰ
//			Ҫ.벿ֲٶ,ֻҪûӻصз,
//			ͻһ.ֻ벻ʾΡ
// : nPort,ͨ
//		 DecCBFun,صָ,ΪNULL.ص:
//			nPort,ͨ
//			pBuf,Ƶ
//			nSize,ƵpBufĳ
//			pFrameInfo,ͼϢ,μFRAME_INFOṹ
//			nReserved1,
//			nReserved2,	
// : BOOL,ɹTRUE,ʧܷFALSE.
//------------------------------------------------------------------------
typedef void (CALLBACK* fDecCBFun)(LONG nPort,char * pBuf,LONG nSize,FRAME_INFO * pFrameInfo, void* pUserData, LONG nReserved2);
PLAYSDK_API BOOL CALLMETHOD PLAY_SetDecCallBack(LONG nPort, fDecCBFun DecCBFun);

//------------------------------------------------------------------------
// : PLAY_SetDecCallBackEx(ʹPLAY_SetDecodeCallBack)
// : ýص,滻еʾ,ûԼʾ,ú
//			PLAY_Play֮ǰ,PLAY_StopʱԶʧЧ,´εPLAY_Play֮ǰ
//			Ҫ.벿ֲٶ,ֻҪûӻصз,
//			ͻһ.ֻ벻ʾΡ
// : nPort,ͨ
//		 DecCBFun,صָ,ΪNULL.ص:
//			nPort,ͨ
//			pBuf,Ƶ
//			nSize,ƵpBufĳ
//			pFrameInfo,ͼϢ,μFRAME_INFOṹ
//			nReserved1,ûԶ
//			nReserved2,	
//		 pUserData,ûԶ
// : BOOL,ɹTRUE,ʧܷFALSE.
//------------------------------------------------------------------------
PLAYSDK_API BOOL CALLMETHOD PLAY_SetDecCallBackEx(LONG nPort, fDecCBFun DecCBFun, void* pUserData);

//------------------------------------------------------------------------
// : PLAY_SetVisibleDecCallBack(ʹPLAY_SetVisibleDecodeCallBack)
// : ص.PLAY_SetDecCallBackExͬ,ͬǽصͬʱ
//			ʾƵ,鲻Ҫڻصʱ߼,ʾʱ.
// : nPort,ͨ
//		 DecCBFun,صָ,ΪNULL,:
//			nPort,ͨ
//			pBuf,Ƶ
//			nSize,ݳ
//			pFrameInfo,֡Ϣ,FRAME_INFOṹ.
//			pUserData,ûԶ
//			pReserved1,.
//		 pUserData,ûԶ.
// : BOOL,ɹTRUE,ʧܷFALSE.
//------------------------------------------------------------------------
typedef void (CALLBACK* fVisibleDecCBFun)(LONG nPort,char * pBuf,LONG nSize,FRAME_INFO * pFrameInfo, void* pUserData, LONG nReserved1);
PLAYSDK_API BOOL CALLMETHOD PLAY_SetVisibleDecCallBack(LONG nPort, fVisibleDecCBFun DecCBFun, void* pUserData);


//------------------------------------------------------------------------
// : PLAY_SetDisplayScale
// : ʾСIOSרԱ䲻ͬĻ.
// : nPort,ͨ
//		 fScaleʾĬΪ1.0
//		 nRegionNum,ʾ,0~(MAX_DISPLAY_WND-1),Ϊ0,õʾ.
// : BOOL,ɹTRUE,ʧܷFALSE.
//------------------------------------------------------------------------
PLAYSDK_API BOOL CALLMETHOD PLAY_SetDisplayScale(LONG nPort, float fScale, DWORD nRegionNum);


//------------------------------------------------------------------------
//	: PLAY_SetSecurityKey
//	: aesԿ
//  :   nPort:		ͨ
//				szKey:		Կָ
//				nKeylen:	Կĳ       
// : BOOL,ɹTRUE,ʧܷFALSE.
//------------------------------------------------------------------------
PLAYSDK_API BOOL CALLMETHOD PLAY_SetSecurityKey(LONG nPort,const char* szKey,DWORD nKeylen);

//------------------------------------------------------------------------
// : PLAY_StartFisheye
// : Ƶ㷨ܣҪfisheye.dll
// : [in]nPort : ͨ
// : BOOL,ɹTRUE,ʧܷFALSE.
//------------------------------------------------------------------------
PLAYSDK_API BOOL CALLMETHOD PLAY_StartFisheye(LONG nPort);

//------------------------------------------------------------------------
// : PLAY_OperateFisheyeParams
// : /ȡ۲
// : [in]nPort					:  ͨ
//		 [in]operatetype			:  
//       [in]pOptParam	    		:  ۲
// : BOOL,ɹTRUE,ʧܷFALSE.
//-----------------------------------------------------------------------
PLAYSDK_API BOOL CALLMETHOD PLAY_OptFisheyeParams(LONG nPort, FISHEYE_OPERATETYPE operatetype, FISHEYE_OPTPARAM* pOptParam);

//------------------------------------------------------------------------
// : PLAY_FisheyeSecondRegion
// : ڸģʽ¿رյڶ۴
// : [in]nPort			: ͨ
//		 [in]hDestWnd		: ʾھ
//		 [in]pOptParam		: ڶڶӦ۲
//		 [in]bEnable		: 򿪻رʾ
// : BOOL,ɹTRUE,ʧܷFALSE.
//------------------------------------------------------------------------
PLAYSDK_API BOOL CALLMETHOD PLAY_FisheyeSecondRegion(LONG nPort, HWND hDestWnd, FISHEYE_OPTPARAM* pOptParam, BOOL bEnable);

//------------------------------------------------------------------------
// : PLAY_FisheyeEptzUpdate
// : eptz(̨ƶ
// : [in]nPort           :  ͨ
//       [in/out]pEptzParam  :  ڲ
//		 [in]bSecondRegion	 	ǷΪģʽµĵڶڣ1Ϊ棬Ĭ0
// : BOOL,ɹTRUE,ʧܷFALSE.
//------------------------------------------------------------------------
PLAYSDK_API BOOL CALLMETHOD PLAY_FisheyeEptzUpdate(LONG nPort, FISHEYE_EPTZPARAM* pEptzParam, BOOL bSecondRegion);

//------------------------------------------------------------------------
// : PLAY_StopFisheye
// : ֹͣƵ㷨
// : [in]nPort : ͨ
// : BOOL,ɹTRUE,ʧܷFALSE.
//------------------------------------------------------------------------
PLAYSDK_API BOOL CALLMETHOD PLAY_StopFisheye(LONG nPort);

//------------------------------------------------------------------------
// : PLAY_SetFishEyeInfoCallBack
// : ûȡۻص
// : nPort,ͨ
//		 pFishEyeInfoFun,صָ,ΪNULL,:
//			nPort,ͨ
//          byCorrectMode,ģʽ
//          wRadius,뾶
//          wCircleX,Բĺ
//          wCircleY,Բ
//			widthRatio, 
//			heightRatio,߱
//			gain, 
//			denoiseLevel, ȼ
//			InstallStyle, ۰װʽ
//		 pUserData,ûԶ.
// : BOOL,ɹTRUE,ʧܷFALSE.
//------------------------------------------------------------------------
typedef void (CALLBACK* fCBFishEyeInfoFun)( 
	LONG nPort,
	BYTE byCorrectMode,
	WORD wRadius,
	WORD wCircleX,
	WORD wCircleY,
	UINT widthRatio,
	UINT heightRatio,
	BYTE gain,
	BYTE denoiseLevel,
	BYTE installStyle,
	void* pUserData );
PLAYSDK_API BOOL CALLMETHOD PLAY_SetFishEyeInfoCallBack(
	LONG nPort, 
	fCBFishEyeInfoFun pFishEyeInfoFun, 
	void* pUserData );

typedef enum
{
	RENDER_NONE = 0,
	RENDER_GDI,
	RENDER_D3D,
	RENDER_DDRAW,

	RENDER_D3D_FAST = 5	 //  DECODE_HW_FAST

}RenderType;

typedef enum
{
	DECODE_NONE = 0,
	DECODE_SW,
	DECODE_HW,
	DECODE_HW_FAST, //ֱԿʾRENDER_D3D_FAST
	DECODE_MSDK
}DecodeType;
/************************************************************************/
/* : PLAY_SetEngine
   : ָ(Windowsƽ̨), PLAY_Play֮ǰЧ
   : nPort,ͨ
	     decodeType, ģʽH264)
	     renderType, Ⱦģʽ
   : BOOL,ɹTRUE,ʧܷFALSE.   
   עһһEngineԽһNONE,
         :PLAY_SetEngine(0, DECODE_MSDK, RENDER_NONE);         */
/************************************************************************/
PLAYSDK_API BOOL CALLMETHOD PLAY_SetEngine(LONG nPort, DecodeType decodeType, RenderType renderType);

/************************************************************************/
/* : PLAY_CheckHWDecEnv
   : ָ(Windowsƽ̨)
   : 
   : BOOL,ַ֧TRUE,ַ֧FALSE.   
   עǰPLAY_SetEngine DECODE_HW Ƿֵ֧֧֡
	PLAY_SetEngine DECODE_HW ʧܡ         */
/************************************************************************/
PLAYSDK_API BOOL CALLMETHOD PLAY_CheckHWDecEnv();

#ifdef __cplusplus
}
#endif

#endif
